QQ登录

只需一步,快速开始

扫一扫,访问微社区

登录 | 注册 | 找回密码

三维网

 找回密码
 注册

QQ登录

只需一步,快速开始

扫一扫,访问微社区

展开

通知     

系统
[系统通知] 每周精选(12/09)
3天前
楼主: kuangben8
收起左侧

[分享] 分享学习AutoCAD编程之VBA笔记 (期初完结!)

[复制链接]
 楼主| 发表于 2019-3-29 19:31:00 | 显示全部楼层
12、很有用的Utility对象7 A6 H4 F$ B: H; O' ]+ P: s5 ]4 n
, G3 c$ i  e' U$ c0 M# n. ~
AUtility对象
提供一系列实用工具方法,VBA类名AcadUtility,访问途径:Thisdrawing.Utility
  方法  
对应作用
AngleFromXAxis  
获取直线与 X 坐标轴的夹角。
AngleToReal  
将角度从字符串转换为双精度实数值。
AngleToString  
将角度从双精度实数值转换为字符串。
CreateTypedArray  
创建包含一组各种参数的变体。
DistanceToReal  
将距离由字符串转换为实数(双精度)值。
GetAngle  
获取指定的角度。考虑 ANGBASE 系统变量的设置。
GetCorner  
获取矩形的角点。
GetDistance  
获取由提示行或由屏幕上选定的一组点的距离
GetEntity  
以交互方式获取对象。
GetInput  
将用户输入的字符串转换为关键词索引。
GetInteger  
从用户处获取整数值。
GetKeyword  
从用户处获取关键词字符串。
GetOrientation  
获取指定角度。忽略 ANGBASE 系统变量的设置。
GetPoint  
获取  AutoCAD 中选定的点。
GetReal  
从用户获取双精度实数值。
GetRemoteFile  
下载由URL指定的文件。
GetString  
从用户获取字符串。
GetSubEntity  
以交互方式获取对象或子图元。
InitializeUserInput  
初始化 GetKeyword 方法。
IsRemoteFile  
返回下载远程文件的源 URL。
IsURL  
验证给定的URL。
LaunchBrowserDialog  
启动  Web 浏览器窗口,允许用户导航到任意 URL 并可指定  URL。
PolarPoint  
获取与给定点指定角度和距离的点。
Prompt  
向命令行发送提示。
PutRemoteFile  
将文件上载到由 URL 指定的远程位置。
RealToString  
将双精度实数值转换为字符串。
SendModelessOperationEnded
指出非模态操作已经结束。
SendModelessOperationStart  
指出非模态操作即将开始。
TranslateCoordinates   
将点从一个坐标系转换到另一个坐标系。

# a- Q- x; X5 |$ K, o5 D
  属性  
对应作用
Application
获取  Application 对象。
& ^$ i2 d& t7 D$ q" b; J0 W

; Q* ^8 ]# c2 [5 f
1 I( y2 v4 l+ m. I" S* a2 A. V/ ~% b8 r' n: |5 t
此贴共有 162 人浏览过
 楼主| 发表于 2019-3-29 19:36:05 | 显示全部楼层
本帖最后由 kuangben8 于 2019-3-29 19:38 编辑 2 ~- P2 q  g8 b) l7 C5 t
' `' `  a6 P1 G: k- P
B. AngleFromXAxis方法
RetVal = AngleFromXAxis(Point1, Point2)
Point1Point2 分别是起点和终点。RetVal是以弧度值表示的线的角度。
  1. Sub AngleFromXAxis方法()
    7 p1 ]1 T4 ~' z( A
  2.     Dim p1(2) As Double, p2(2) As Double
    0 ?0 u8 p- Q  V0 z
  3.     Dim angle As Double- s/ {' k( e& {; c
  4.     p1(0) = 10: p1(1) = 10
    9 j$ f3 }# ^  ~) X% U5 s7 j9 K
  5.     p2(0) = 60: p2(1) = 90
    & J8 Q! K) ~0 W4 @) L2 ]3 n
  6. angle = ThisDrawing.Utility.AngleFromXAxis(p1, p2)% r. S+ Z1 H% F" q+ Q: q1 \1 {
  7. angle = ThisDrawing.Utility.AngleFromXAxis(p2, p1)0 ~# A7 |3 j) c/ A+ ?" [8 l
  8.     Rem 可以不用画直线而直接获得两点对应直线的角度,注意起点不同的相同直线角度也不同。
    5 O+ y- w" ?2 v, U
  9. End Sub
复制代码

3 J9 e+ H  ]0 a. VC.AngleToReal方法
RetVal = AngleToReal(Angle, Unit)
AngleString[字符串]; 仅用于输入,以字符串值表示的角度。
UnitAcAngleUnits 常数; 仅用于输入需要转换到的单位。
acDegrees 角度字符串转为弧度值   
acDegreeMinuteSeconds 度分秒字符串转换为弧度值
acGrads 梯度字符串转换为弧度值                     
acRadians 弧度字符串转换为弧度值

- j; V5 h8 D0 f- S+ G
RetVal以弧度实数表示的角度。
  1. Sub AngleToReal方法()
    0 X+ a& D7 p, Q' l5 t7 o
  2.     Dim angAsStr As String; E: q0 r9 J6 S6 b0 Y
  3.     Dim unit As Integer/ F3 X4 `8 o% n' g" ~+ r, o) G* K
  4.     Dim angAsReal As Double
    + G5 K& I9 R& l" O
  5.    
    * {. \- N, L- o( H( ~; S2 o
  6.     angAsStr = "180"( x: o# t+ k' A$ U6 l
  7.     unit = acDegrees   '角度转弧度2 Z; o9 F. @! o: [! `
  8.     angAsReal = ThisDrawing.Utility.AngleToReal(angAsStr, unit)
    7 G( O1 a7 F8 N7 d
  9.     MsgBox "180°转为弧度是 " & angAsReal & " 弧度", , "AngleAsReal 示例". M$ N. a+ U2 E6 `; U
  10. 4 k& `0 j6 Y# n& b( E5 |
  11.     angAsStr = "180d0' 0"""; G$ W2 n4 ?8 I9 m- S
  12.     unit = acDegreeMinuteSeconds '度分秒转换为弧度2 u! T& z6 P) e4 k
  13.     angAsReal = ThisDrawing.Utility.AngleToReal(angAsStr, unit)9 n) O4 Y! b! B+ S% ~5 ?; T0 m, n
  14.     MsgBox "180°0’0""转换为弧度是 " & angAsReal & " 弧度", , "AngleAsReal 示例"% N- m. j( j4 r* M! j1 N9 H, X
  15.    
    5 ~! Y* _  n' L) ]7 f2 j
  16.     ' 下面是以梯度单位给出的角度转换为弧度% I- r2 @1 v, f4 ]# K' O9 w
  17.     angAsStr = "90"
    ! g: G. i* o2 `; n
  18.     unit = acGrads
    7 d$ O; j4 |' c: Z' @7 X0 z4 ]
  19.     angAsReal = ThisDrawing.Utility.AngleToReal(angAsStr, unit)
    ( }$ [% @0 I  r" f% H
  20.     MsgBox "90梯度转换为弧度是" & angAsReal & " radians.", , "AngleAsReal 示例"8 a  l. ^# D5 @8 `
  21.     : P% r  E* K* G+ k* n" e
  22.     '下面是将弧度字符串转换为弧度, {3 {2 x; D2 ~2 f% O
  23.     angAsStr = "3.1415926535897932"
    # D: J& Z1 d' A: k, F5 w
  24.     unit = acRadians' V* j4 ~1 U8 x  v3 a  k% m- |% I
  25.     angAsReal = ThisDrawing.Utility.AngleToReal(angAsStr, unit)
    % j. c2 ]1 N. j! S: @
  26.     MsgBox "π弧度转换为弧度是" & angAsReal & " radians.", , "AngleAsReal 示例". E1 E1 S, v6 B
  27.    
    1 @1 m: Q) `6 x6 d, E/ d
  28. End Sub
    2 C; Q1 y/ y# y
复制代码

7 O* S# s* J- uD.AngleToString方法
RetVal = AngleToString(Angle, Unit,Precision)
Angledouble类型,用于输入的值
UnitAcAngleUnits 单位常数; 仅用于输入
acDegrees 将角度值转为字符串
acDegreeMinuteSeconds 将度分秒值转换字符串
acGrads 将梯度值转为字符串
acRadians 将弧度值转为字符串
PrecisionInteger[整数]; 仅用于输入,角度的精度。在 0 8 之间的整数。

, s2 D0 h; g0 \3 I6 _
ReVal以字符串表示的角度
  1. Sub AngleToString方法()
    # g9 C# E3 q7 H3 N' X6 u2 v
  2. '此示例将弧度值转换为几个不同的以不同单位表示值的字符串。6 v. z7 G* b, Q; u: x
  3.     Dim angAsRad As Double5 M/ Z, L# p# q# y5 z
  4.     Dim unit As Integer
    2 n) T5 L7 \8 V! }8 p
  5.     Dim precision As Long
    & z, O0 i, r, H6 d
  6.     Dim angAsString As String. Z! o; l9 x0 b1 H+ J
  7.     angAsRad = 3.14159265358979    '以π弧度为例
    / J5 T3 _# o! S4 K3 v
  8.     unit = acDegrees   '将弧度表示的角度转换为字符串. u( R6 |9 M  ~* ^, w: s; l" k
  9.     precision = 6
    1 b8 w. R6 n- l: r. J
  10.    
    8 H' D" w+ g) ]+ [& G& x3 l$ J
  11.     '将弧度值转换为精度为6的度数+ k* i' E3 V# v- }
  12.     angAsString = ThisDrawing.Utility.AngleToString(angAsRad, unit, precision)    '结果是 "180" 。
    9 U/ k$ i* y, }) \3 T' b( [
  13.     MsgBox "π弧度= " & angAsString & " 度", , "AngleAsString 示例"
    + O# q; E8 g3 a& A" H
  14.     9 N( h+ M# O5 e9 `1 H5 s9 g& L$ u6 E
  15.     ' 将弧度值转换为度/分/秒,精度为6
    8 Y  o+ h  |/ i" r2 a4 G
  16.     unit = acDegreeMinuteSeconds
    & A5 z( K# R! X/ ]! _) L8 O
  17.     angAsString = ThisDrawing.Utility.AngleToString(angAsRad, unit, precision)     '结果是 "180d0'0.00"" 。& R+ G. W# T& y  j4 R
  18.     MsgBox "π弧度 =  " & angAsString, , "AngleAsString 示例", `4 `$ _" @1 D) K) z5 b7 E! F1 t: I
  19.     + O0 t- @1 l/ B/ }$ x" T6 P
  20.     '将弧度值转换为精度为6的梯度值字符串7 q. a: k! H2 U# E8 F: N
  21.     unit = acGrads9 F% l# b* D# s* [; n
  22.     angAsString = ThisDrawing.Utility.AngleToString(angAsRad, unit, precision)    '结果是 "200g" 。
    3 I9 b5 h1 L' {/ e6 j, ^. R1 x  n1 p. ^
  23.     MsgBox "π弧度=  " & angAsString, , "AngleAsString 示例"
    8 }$ J7 v# N5 `$ T
  24.    
    ; [% F+ Y! _" V# F- j
  25.     '将弧度值转换为精度为6的弧度值字符串( J8 P; ]% `7 }$ p  \
  26.     unit = acRadians
    * n( U' t0 Z  f3 o- _0 K2 p0 l' h
  27.     angAsString = ThisDrawing.Utility.AngleToString(angAsRad, unit, precision)    '结果是 "3.141593r" 。
    ; _  [/ t% _7 H; Z
  28.     MsgBox "π弧度=  " & angAsString, , "AngleAsString 示例"2 q% b5 C7 `! r( V0 z9 u
  29. End Sub- `' @+ c9 [8 u6 ^. V/ i' @8 U9 R
复制代码
% \* ^  A0 F6 V) L" `; X1 Y
 楼主| 发表于 2019-3-29 20:40:08 | 显示全部楼层
E.CreateTypedArray方法
CreateTypedArray(VarArr, Type, Value1,[value2, value3, ...valueN])
VarArr: Variant[变体]; 仅用于输出,作为变体的数组值。
Type: Visual Basic 常数; 仅用于输入用户提供的类型值。
: `# d! }$ m  ovbBoolean, vbInteger, vbLong, vbSingle, 或 vbDouble。
Value1,……ValueN:在上面 Type 参数中指定的类型; 仅用于输入包含在变体中的值。
说明:结果变体可传递给接受作为变体的数值数组的任何 AutoCAD 方法或属性。该方法只能使用后期绑定编程技术访问。
要使用该方法,可将 Utility 对象定义为 Object (Dim myObj As Object), 而不是 as AcadUtility
  1. Sub CreateTypedArray方法()3 g" u- w% D0 O
  2. '此示例使用CreateTypedArray方法从Double创建的变量数组创建样条线。
    3 l* v: x4 A: w; q8 P
  3. '请注意,此方法必须是后期绑定的。这是通过将实用程序对象(utilobj)声明为对象而不是AcadUtility来实现的。
    ' M7 q- L7 n5 |6 G
  4.     Dim splineObj As AcadSpline
    - R0 V" n4 d  h( {8 x
  5.     ' 即使这些是数组,它们也被声明为变体变量" r5 E9 l- V' F
  6.     Dim startTan As Variant
    ; i& z. r3 R9 K8 T
  7.     Dim endTan As Variant5 S! i* ~: o: ]6 d# F+ O* L
  8.     Dim fitPoints As Variant+ i& r( }5 W/ n8 M! p" G9 U: E
  9.     Dim utilObj As Object   ' 后期绑定对象
    . h4 i( [/ A7 x4 n# r& O
  10.     Set utilObj = ThisDrawing.Utility
    6 y2 F( l! ^9 l* g0 t9 ]7 ?
  11.     ' 定义样条曲线.
    * w: U/ U- f1 X' o8 f* k, E
  12.     utilObj.CreateTypedArray startTan, vbDouble, 0.5, 0.5, 0
    - D% Y% {* |! ]
  13.     utilObj.CreateTypedArray endTan, vbDouble, 0.5, 0.5, 0
    5 W# i8 m/ v1 X0 `! S% ?
  14.     utilObj.CreateTypedArray fitPoints, vbDouble, 0, 0, 0, 5, 5, 0, 10, 0, 0
    7 x! u) T: d2 ]* e' B+ c$ ]. \: H1 s
  15.     ' 创建样条曲线
    & h" _% _8 I  Y- m
  16.     Set splineObj = ThisDrawing.ModelSpace.AddSpline(fitPoints, startTan, endTan)6 p1 y( P; S+ n1 I2 i" {5 I
  17.     ZoomAll
    9 Y& I( _) O$ @) M, S. v! A
  18. End Sub
复制代码

, p' k& c  E8 Z8 z* n
. A, `! z  M2 y, u6 j9 A& uF.GetAngle方法
RetVal = GetAngle([Point][, Prompt])
PointVariant[变体] (三元素双精度数组); 仅用于输入; 【可选项】指定第一点的三维WCS坐标。
PromptVariant[变体] (字符串); 仅用于输入; 【可选项】用于提示用户输入的文字。
RetValDouble[双精度],以弧度表示的角度。  
说明
AutoCAD暂停,等待用户输入角度,并设置返回值为已选角度的值。Point 参数指定了角度在二维WCS中的基点。Promp 参数指定在 AutoCAD 暂停时显示的字符串。Point 和 Prompt 参数为可选项。
AutoCAD用户可以通过以当前角度单位格式输入数值来指定角度。用户也可以通过在图形屏幕指定两个二维位置来设置角度。AutoCAD 从第一个点画一条橡皮筋线到当前十字光标位置以便用户看到角度。如果给出了 Point 参数,AutoCAD 用这个值作为两点中的第一点。该角度只测量 WCS 坐标下 XY 平面(GetAngle 忽略点的 Z 轴值)。
虽然 GetAngle 方法是用来指定角度,但它总是把返回值设置为以弧度表示的值。角度的加大方向始终是逆时针。
该函数差不多和GetOrientation一样,但它是按系统变量 ANGBASE 的当前值来计算。对于 GetOrientation,零角度总是向右:“东向”或“时钟的三点”。对于 GetAngle,零角度是 ANGBASE 系统变量的值,该值可设置任何四个90度象限。GetAngle 和 GetOrientation 都返回一个从基准角(零度角)逆时针测量的角的弧度值(实数)。对于 GetAngle,基准等于 ANGBASE 的值;对于 GetOrientation,基准在右侧。两个函数都有当前 ANGDIR 的值,这个值影响当前用户输入的值,但不影响函数的返回值。
可以用 GetAngle 来获得要插入块的旋转量,因为输入0度总是返回0弧度。可用 GetOrientation 来获得一个文字图元的基线角度以便与其它对象对齐。
如果返回的值不是角度而是关键字,AutoCAD 将生成“用户输入关键字”的错误信息。用 GetInput 方法可以从返回值中获得关键字。
  用户输入 (角度)
GetAngle  返回值
GetOrientation  返回值
0
0.0
1.5708
-90
1.5708
3.14159
180
3.14159
4.71239
90
4.71239
0.0
  ?7 J3 S' [4 d
  1. Sub GetAngle方法()
    / i) j- ^! t& e4 S
  2. '此示例演示了4种不同方法使用getAngle方法从用户检索角度。
    : Q* T- d5 m3 R
  3.     Dim retAngle As Double2 }- `' K" O3 d# D
  4.     ' 返回以弧度表示的角度并提示  N* G7 B; m" x) [8 z
  5.     retAngle = ThisDrawing.Utility.GetAngle(, "请输入角度: ")         '输入 90 回车% u' v6 V" t" t/ R) `2 P! I5 R4 i
  6.     MsgBox "被输入的角度是" & retAngle, , "GetAngle 示例"        '返回的是π/2=1.570796....。
    * g& E2 Y- k' e- h! f
  7.     ' 无提示返回以弧度表示的角度3 D+ Q8 j$ g2 M- Q$ x2 U) T% r
  8.     retAngle = ThisDrawing.Utility.GetAngle()      '该写法与上面的区别是:在模型空间的十字光标上没有提示
    : {5 Z" z" k" L# f. J. \5 S" Q* |
  9.     MsgBox "输入的角度是 " & retAngle, , "GetAngle 示例"
    ( K( Z4 a4 t4 u0 v7 a
  10.     ' 返回带有提示和角度基点的以弧度表示的角度
    3 \# d( V9 X% ~% \& V
  11.     Dim basePnt(0 To 2) As Double
    % G4 |: a' F& l' u1 O  I* w
  12.     basePnt(0) = 2#: basePnt(1) = 2#: basePnt(2) = 0#
    0 L5 \. B% Q9 G0 L; h  o0 t( {
  13.     retAngle = ThisDrawing.Utility.GetAngle(basePnt, "请输入角度: ")     '模型空间的十字光标从基点坐标引出一条橡皮筋线跟随光标走
    ! [" e% i8 `5 k& W) O: I" e- ]
  14.     MsgBox "输入的角度是: " & retAngle, , "GetAngle 示例"
    7 u6 N0 f7 ?0 k4 W: Y0 N6 t/ g
  15.     ' 返回带有角度基点但没有提示的弧度角度
    ! r- F" s3 p* H. L8 J6 Q9 n
  16.     retAngle = ThisDrawing.Utility.GetAngle(basePnt)
    - D% x2 T; s/ E" D
  17.     MsgBox "输入的角度是:" & retAngle, , "GetAngle 示例"
    ) z+ q- D- R: k* T9 I" z; D
  18. End Sub
复制代码
1 \5 B) z. E8 t4 J& H7 N
: Y; o+ w1 X" Y6 c

# l/ Q( Y4 a$ r" ?. t( G; \1 P$ J
/ s0 ?4 u$ l0 E5 I3 d& `
 楼主| 发表于 2019-3-29 20:42:56 | 显示全部楼层
G.GetCorner方法
RetVal = GetCorner(Point[, Prompt])     ‘相当于手动画矩形,但不画矩形,而是获取另一角点坐标。
PointVariant[变体] (三元素双精度数组); 仅用于输入,指定矩形基点的三维WCS坐标点。
PromptVariant[变体] (字符串); 仅用于输入; 【可选项】用于提示用户输入的文本。
RetValVariant[变体] (三元素双精度数组),表示矩形框另一角点的三维WCS坐标。
说明
AutoCAD暂停,等待用户输入矩形的角点,然后将返回值设成选取点的值。Point 参数指定了矩形基点的三维WCS坐标;该参数是必需的。Prompt 参数指定了在AutoCAD暂停时显示字符串。该提示是可选项。
AutoCAD用户可以通过输入一个WCS格式的坐标点来指定角点;GetCorner 将点作为一个三维空间的点。用户也可以通过在图形屏幕上指定位置确定角点。AutoCAD从基点到当前十字光标处画出一个有动态大小的矩形来帮助用户认清第二个角点的位置。矩形是在WCS的XY平面中画出。当用点设备时,GetCorner忽略点的Z值,设置Z值的结果为当前标高。
  1. Sub GetCorner方法()
    2 s& M7 z5 U) N7 a* ?7 j4 f
  2. '此示例提供一个基点,并提示用户输入第二个点以生成矩形。  S* B6 _% a0 u' }. f) x8 n6 n2 X
  3.     Dim returnPnt As Variant9 {- U7 J8 k4 o
  4.     Dim basePnt(0 To 2) As Double7 D8 m' |9 A  A; I) A
  5.     basePnt(0) = 2#: basePnt(1) = 2#: basePnt(2) = 0#% B9 p2 z  A6 i  h: d; E
  6.     ' 提示用户选择第二个点并返回该点坐标
    ! x( e, |# ^; K6 O) @& w1 Q3 q5 e( M
  7.     returnPnt = ThisDrawing.Utility.GetCorner(basePnt, "请输入另一个角点: ")    '另一个角点可以输入,可以点击选取: S0 [( R4 q( \9 w: _) d
  8.     ' 显示拾取的点- m0 M) e& l% F: ]) h1 t
  9.     MsgBox "拾取的点坐标是 " & returnPnt(0) & ", " & returnPnt(1) & ", " & returnPnt(2), , "GetCorner 示例"
    * X1 q$ o4 r7 Q
  10. End Sub
复制代码

% W: P- k' F) Q# Q) l
H.GetDistance方法
RetVal = GetDistance([Point][,Prompt])   获取(由提示行或由屏幕上选定的一组点的)距离
PointVariant[变体] (三元素双精度数组); 仅用于输入;【可选项】指定基点的三维 WCS坐标。如果该点未提供,用户必须输入两个点。
PromptVariant[变体] (字符串); 仅用于输入;【可选项】提示用户输入的文本。
RetValVariant[变体] (双精度或双精度数组),从提示行或从屏幕上选定一组点的距离。
说明
AutoCAD暂停,等待用户输入一个线性距离,设置选择的距离为返回值。Point 参数指定了一个WCS坐标系下的基点。Prompt 参数指定了AutoCAD在暂停前显示的字符串。Point 和 Prompt 都是可选的。
AutoCAD用户可以通过输入以当前单位为格式的数值来指定距离。用户也可以通过在图形屏幕上指定两个位置来设置距离。AutoCAD从第一个点到当前十字光标位置画一个橡皮筋线以帮助用户认清距离。如果提供了 Point 参数, AutoCAD将此值作为两个点的第一点值。
默认状态下,GetDistance 把点和返回值看作是三维点。事先调用 InitializeUserInput 方法可以使点成为二维点,以保证该方法返回的是二维平面距离。
本方法除了用于指定距离或当前线性单位(如英尺和英寸),还可经常用来设置双精度浮点的返回值。
  1. Sub GetDistance方法()
    2 g$ ?7 |+ ^1 f( {) S
  2.     ' 此示例返回用户输入的距离。用户可以输入单个距离值,也可以输入或点选两个点,返回两点的距离。8 |8 i8 z. h$ p/ J+ B  o2 l9 z
  3.     Dim returnDist As Double7 c1 t, h: H0 Y5 s+ j; \
  4.     Dim basePnt(0 To 2) As Double' D0 j, ?' A! A, Y* |) H1 a+ R
  5.     basePnt(0) = 0#: basePnt(1) = 0#: basePnt(2) = 0#
    1 f3 E# B9 w5 {- ?" x! w& H. F  j
  6.     ' 返回用户输入的值。提供提示.
    & p- F) q- [- w) O/ K. d" d+ Z! v
  7.     returnDist = ThisDrawing.Utility.GetDistance(, "请输入距离: ")  n: M  P* a9 E$ _8 d1 R9 ^5 g
  8.     MsgBox "输入的距离是:" & returnDist & vbCrLf & "(输入下一个值而不提示.)", , "GetDistance 示例"% M7 U) T5 S( M3 q: K* @
  9.     '返回用户输入的值。不提供提示。
    7 L- q6 D5 L+ K+ E/ w7 `
  10.     returnDist = ThisDrawing.Utility.GetDistance()) {% g: i1 N! P4 X/ V$ ]0 x( J
  11.     MsgBox "输入的距离是:" & returnDist, , "GetDistance 示例"
    $ o/ J7 e1 i) W3 h
  12.     ' 返回用户输入的值。提供基点和提示。
      ?$ g7 d% b& U9 o3 g
  13.     returnDist = ThisDrawing.Utility.GetDistance(basePnt, "请输入距离: ")9 `: R2 j" p% Z: m6 y
  14.     MsgBox "输入的距离是:" & returnDist, , "GetDistance 示例"
    + \$ `2 b9 M0 m3 D2 x4 T  J. H! Q+ z
  15. End Sub
复制代码

5 N9 w$ ^7 f& Q
$ i, B# {5 A+ H; p! ?) `! k7 A  G
 楼主| 发表于 2019-3-29 20:46:20 | 显示全部楼层
I.GetEntity方法
object.GetEntity Object, PickedPoint[, Prompt]
ObjectObject; 仅用于输出,拾取的对象,可以是任意图形对象中的一个。
PickedPointVariant[变体] (三元素双精度数组); 仅用于输出,表示选择点的三维 WCS 坐标。
PromptVariant[变体] (字符串); 仅用于输入;【可选项】用于提示用户输入的文本
说明
该方法需要 AutoCAD用户在图形屏幕上拾取一个点来选择一个对象。如果选定了对象,该方法将把它作为第一个参数返回,第二个参数包含了拾取点在WCS下的坐标。如果拾取点不在对象上,该方法调用失败。
GetEntity 返回的拾取点并不需要在已选定的对象上。返回的点只表示选择时十字光标的位置。点与对象的关系会因拾取框的大小和当前的缩放比例而变化。
该方法甚至可以取出在屏幕上不可见的或在冻结层的对象。
  1. Sub Example_GetEntity()9 H0 W4 ?4 `8 ~, e8 @
  2.     '此示例在模型空间中创建多个对象。然后提示用户选择对象。
    ' `( }/ `( J+ u' t
  3.     '该示例继续让用户选择对象,直到用户在空白空间中选择。在模型空间中创建一个光线对象。
    : ]- c8 V) R* i9 T3 w
  4.     Dim rayObj As AcadRay    '定义射线变量
    ; G: o9 w! b. c$ `
  5.     Dim basePoint(0 To 2) As Double
    6 u& j, F1 b' h, s9 F/ |& m
  6.     Dim SecondPoint(0 To 2) As Double, h9 i0 A' t" _2 a  P& c
  7.     basePoint(0) = 3#: basePoint(1) = 3#: basePoint(2) = 0#
    7 w" k" ^  f% B' O# h
  8.     SecondPoint(0) = 1#: SecondPoint(1) = 3#: SecondPoint(2) = 0#/ L$ U1 Y& A: ~
  9.     Set rayObj = ThisDrawing.ModelSpace.AddRay(basePoint, SecondPoint)
    0 ?8 w' Q" s8 h7 S/ F- B. N
  10.     Update; ]9 T. u3 m' k# f
  11.     ' 在模型空间中创建多段线对象- {1 M$ m1 B* Z
  12.     Dim plineObj As AcadLWPolyline
    5 w/ |' F7 k, n- }( u& ^6 y
  13.     Dim points(0 To 5) As Double9 G( Y9 p0 N/ E8 M6 s1 o
  14.     points(0) = 3: points(1) = 7
    ' O6 O- `) s3 o) R2 `
  15.     points(2) = 9: points(3) = 2
    8 g7 g2 k2 c# ~+ m" I5 ?* ?
  16.     points(4) = 3: points(5) = 5
      _& a# D7 R, Z3 v' H; S
  17.     Set plineObj = ThisDrawing.ModelSpace.AddLightWeightPolyline(points)9 `9 a( p3 m1 t- L  H/ u
  18.     plineObj.Closed = True    '让多段线闭合
    6 j! p+ |7 x) W4 T  q, H5 A1 ^: y
  19.     Update
      T0 {2 s% c& r
  20.     ' 在模型空间中创建线条对象
    2 ?: q3 X9 Z. u. q2 P
  21.     Dim lineObj As AcadLine- p8 P5 q( O+ O' m* R' ~2 @
  22.     Dim startPoint(0 To 2) As Double
    1 b# R8 x* i' _  Z8 ]
  23.     Dim endPoint(0 To 2) As Double' N- |0 u3 h( e
  24.     startPoint(0) = 0: startPoint(1) = 0: startPoint(2) = 0
    8 u, @* ]/ c3 I0 O; i, c- {
  25.     endPoint(0) = 2: endPoint(1) = 2: endPoint(2) = 0
    ! `3 B9 @' i5 I/ P$ x, h' T* O/ M
  26.     Set lineObj = ThisDrawing.ModelSpace.AddLine(startPoint, endPoint)
    7 ~1 U) W, i, z7 Y' J
  27.     Update
    : o5 _4 X/ Z! K1 Z
  28.     ' 在模型空间中创建圆形对象
    - d+ @% N# J6 c; v. m
  29.     Dim circObj As AcadCircle
    4 z: r7 R5 t2 {- V
  30.     Dim centerPt(0 To 2) As Double) k8 c" u% L; F. K5 f
  31.     Dim radius As Double
    * s7 Y" Q9 c2 ?
  32.     centerPt(0) = 20: centerPt(1) = 30: centerPt(2) = 0
    / m" P; ^4 t( a8 q" w
  33.     radius = 3) s: N3 G! N, q. @* l
  34.     Set circObj = ThisDrawing.ModelSpace.AddCircle(centerPt, radius)7 A# G" d# B- a7 U! E
  35.     Update* d$ @8 H: O2 [  s  A! x
  36.     ' 在模型空间中创建椭圆对象
    # @# p8 a" V- F, E' Q) X6 s, @& L) y
  37.     Dim ellObj As AcadEllipse
    . P" r! a8 |. k* o. p9 x
  38.     Dim majAxis(0 To 2) As Double
    ; T- k+ Q0 q! r/ t
  39.     Dim center(0 To 2) As Double3 b! X) h+ I1 {# J
  40.     Dim radRatio As Double
    ) O7 k, H' m) R* w
  41.     center(0) = 5#: center(1) = 5#: center(2) = 0#9 x8 U  \6 V4 G' W4 p
  42.     majAxis(0) = 10: majAxis(1) = 20#: majAxis(2) = 0#
    7 f+ b& S; i9 c, n
  43.     radRatio = 0.3
    ' v9 \# |) ~1 l/ j* m/ u; ]
  44.     Set ellObj = ThisDrawing.ModelSpace.AddEllipse(center, majAxis, radRatio)( H# L$ f  R- w4 B) M/ |
  45.     Update
    # T  w9 \; _$ X, `! ~) P# u
  46.     ' 开始选择
    + L) v7 C2 \; w9 G* L
  47.     Dim returnObj As AcadObject
    . ~% ~& t- p& x0 q
  48.     Dim basePnt As Variant. p4 {# y/ j' B$ o6 S
  49.     On Error Resume Next: b8 w% v: a& e# W3 K% j! p
  50.     ' 下面的示例等待来自用户的选择
    ; M3 b9 `( J" z+ q! _+ A* V
  51. RETRY:
    - c8 J/ q: m1 X0 Y4 l0 d; e5 }
  52.     ThisDrawing.Utility.GetEntity returnObj, basePnt, "请选择一个对象"8 C) p8 o3 U! r
  53.     If Err <> 0 Then     '如果拾取点不在对象上会出错!
    ' @: J, a$ r" ?# U* k0 s9 i$ D
  54.         Err.Clear
    ) H  }  |0 V( z; k3 H; b1 g4 o1 }
  55.         MsgBox "结束程序", , "GetEntity 示例". h0 v4 \% T' k. c3 G7 S7 v, |
  56.         Exit Sub
    " B" q' W  t6 s8 U& N; _
  57.     Else
    5 o  d7 D+ f" |3 i
  58.         returnObj.Update     '刷新选择的对象
    ! j, z1 p9 r% i2 B' I( u" f. Z& F
  59.         MsgBox "对象类型是: " & returnObj.EntityName, , "GetEntity 示例"      '返回图元名称,LINE的是ACDBLINE,circle是acdbcircle等等。! u% H; a  q# J- Q  X
  60.         MsgBox "对象类型是: " & returnObj.ObjectName, , "GetEntity 示例"      '返回值同上2 ~- O2 e; F1 Q5 f, ^: l4 l
  61.         MsgBox "对象类型是: " & returnObj.ObjectID, , "GetEntity 示例"        '返回值一串数字
    - r, T; U' `3 y# c5 Z
  62.         MsgBox "对象类型是: " & returnObj.ObjectID32, , "GetEntity 示例"      '返回值两位数字
      e' |( }8 R2 C
  63.         MsgBox "对象类型是: " & returnObj.OwnerID, , "GetEntity 示例"         '返回值一串数字
    ; i6 O) E0 ]4 S4 I
  64. '        returnObj.Update    '此句作用似乎不明显!
    & K* ?0 m' `. G- d
  65.     End If
    0 q# Q) G/ w' w
  66.     GoTo RETRY+ o3 F, u  ~+ M3 E  f7 r3 v
  67. End Sub
复制代码
8 W2 U; D3 x0 N5 q# g
以上示例似乎没有感受到PickedPoint的效果!!
J.GetInput方法
RetVal = GetInput()   结果是字符串,指定输入了哪个关键词的索引。
不怎么用,暂略。。。。。。
& }8 _8 f/ b! [9 `  e3 F
 楼主| 发表于 2019-3-29 20:48:03 | 显示全部楼层
K.GetInteger方法
RetVal = GetInteger([Prompt])
PromptVariant[变体] (字符串); 仅用于输入;【可选项】提示用户输入的文本信息。
RetValInteger[整数],用户返回的整数值。
AutoCAD 暂停,等待用户输入一个整数,将选择的值作为返回值。Prompt 参数指定了 AutoCAD 在暂停前显示的字串。Prompt 为可选项。
AutoCAD 用户可以输入任何有效的(短)整数,范围从 -32768 到 +32767 之间。
如果返回的不是整数而是关键词,或者是用户没有输入值直接按回车键,AutoCAD 则生成错误号-214530928(错误信息为“用户输入一个关键词”)。使用 GetInput 方法可以从返回值中获取关键词。
  1. Sub GetInteger方法()+ B* H& W" v9 c% c8 ^9 M2 D/ j
  2.     ' 此示例返回用户输入的整数。
    . C: m! {2 u; M7 Q% A8 k
  3.     Dim returnInt As Integer
    # c9 Z6 h; X* S* z+ x: m( q
  4.     ' 返回用户输入的值。提供提示。
    0 `) f1 |6 L6 v0 t7 D. r3 C
  5.     returnInt = ThisDrawing.Utility.GetInteger("请输入一个整数: ")
    ( U8 H4 m4 F6 L6 ~  ^; R$ R1 \5 n" N; E# F
  6.     MsgBox "输入的整数是 " & returnInt & vbCrLf & "(输入下一个值而不提示。)", , "GetInteger 示例"& Y3 n7 m/ b4 `
  7.     '返回用户输入的值。不提供提示。
    4 @1 ~2 H8 l' `, O! R
  8.     returnInt = ThisDrawing.Utility.GetInteger()
    % r# Z" c" f* A' M8 {( `! J
  9.     MsgBox "输入的整数是" & returnInt, , "GetInteger 示例"
    1 X7 M6 x& i/ s6 Q& z; Q; [2 A* D
  10. End Sub
复制代码
  M# q$ e% W2 H8 O# c" ]8 P
- B' q, l* U8 @$ N& y1 \3 [
* e6 B. n) ~0 o+ P1 d4 }
L.GetKeyWord方法
RetVal = GetKeyword([Prompt])
Prompt: Variant[变体] (字符串); 仅用于输入;[可选项]用于提示用户输入的文本。
RetVal: 字符串,用户返回的关键词。
说明
AutoCAD 暂停,等待用户输入一个关键词,并将输入关键词的值设为返回值。Prompt 参数指定了在 AutoCAD 暂停之前显示的字串。Prompt 为可选项。返回值的最大长度为511个字符。
AutoCAD 用户可以通过键盘输入一个关键词。该方法接受的关键词列表是由事先调用 InitializeUserInput 方法来设置的。如果用户输入的字串没有在调用 InitializeUserInput 所指定的关键词中,AutoCAD 显示一个错误信息并重试(如果指定有提示,则重新显示提示)。如果用户没输入任何值只是按下回车键,GetKeyword 返回一个空字串(""),除非调用 InitializeUserInput 时不允许 NULL 输入。
  1. Sub GetKeyword方法(). [1 }7 N( f: D/ {! L" b8 j
  2.     '此示例使用GetKeyword返回用户输入的关键字。InitializeUserInput建立有效的关键字。
    : |1 }6 W- I* @  I+ g, e
  3.     ' 定义有效关键字列表- f, H( U* G- _) X% ^( E
  4.     Dim kwordList As String
    & z' y  C: ?: e% H$ d  y! j+ t3 A
  5.     kwordList = "Width Height Depth WWE High"% L. c/ L% q( z. t* x
  6.     ThisDrawing.Utility.InitializeUserInput 1, kwordList7 p3 h$ g$ K, T: `' ~
  7.     ' 提示用户输入的任何的两个关键词。返回“宽”、“高”或“深度”returnstring变量取决于是否在用户输入“W”,“H”或“D”。
    & }& o7 S9 G2 v/ t
  8.     Dim returnString As String5 [7 S8 m+ g( `) b
  9.     returnString = ThisDrawing.Utility.GetKeyword("输入一个关键字 (Height)(Width)(Depth)(WWE): ")
    & r5 p6 U5 S; \! \
  10.     '用户可以只输入首字符,然后自动识别,当有多个首字符相同时返回第一个对应首字符的字符串关键字
    : \8 \. E9 E% s2 o: s5 l6 W
  11.     MsgBox "你输入了" & returnString, , "GetKeyword 示例"
    , r) g2 I/ Q9 z; P& p
  12. End Sub
复制代码

* B( Q, @7 h% Z# q* k* l" x! ^8 ?6 p& f. H! j: Y
 楼主| 发表于 2019-3-29 20:49:54 | 显示全部楼层
M.GetOrientation方法
RetVal = GetOrientation([Point][,Prompt])       获取指定角度。忽略ANGBASE 系统变量的设置。
Point: Variant[变体] (三元素双精度数组); 仅用于输入; [可选项]指定基点的三维 WCS 坐标。
Prompt: Variant[变体] (字符串); 仅用于输入;[可选项]提示用户输入的文本信息。
RetVal: Double[双精度],指定的角度。
说明
AutoCAD 暂停,等待用户输入一个角度,并将选择角度的值作为返回值。Point 参数指定角度在三维 WCS 中的基点。Prompt 参数指定 AutoCAD 在暂停前显示的字符串。Point 和 Prompt 都是可选项。
AutoCAD 用户可以通过输入一个以当前角度单位格式为单位的数值来确定一个角度。用户也可以通过在图形屏幕上指定两个二维位置来确定角度。AutoCAD 画一条橡皮筋线到当前十字光标位置以帮助用户认清角度。如果提供了 Point 参数,AutoCAD 用这个值作为两点的第一个点值。角度是在WCS坐标系中的XY平面测量的(本方法忽略点的Z值)。角度的方向逆时针为增。
除了指定角度,GetOrientation还经常用来设置以弧度表示的值的返回值。
该方法与 GetAngle方法相似,但它忽略保存在 ANGBASE 系统变量中的当前的0角度的方向。0角度在 GetOrientation 中一般指向右:“东方”或“时针的三点”。
如果返回的是关键词而不是角度,AutoCAD将生成错误信息“用户输入关键词”。用 GetInput 方法可以从返回值中获得关键词。
  1. Sub GetOrientation方法(); }# g9 e- `# h+ i$ ^) ^5 ]
  2.     '此示例使用getOrientation方法演示从用户检索方向的三种不同方法。
    # V2 U6 D2 A- |7 I, w; A* ]4 Z
  3.     Dim retOrientation As Double
    . T9 Q. a. o9 U. u# G( r% _
  4.     ' 返回以弧度表示的方向并提示
      u  v  M4 R- X: J( _
  5.     retOrientation = ThisDrawing.Utility.GetOrientation(, "输入一个角度: ")    '输入90,结果返回的是π/2=1.57.....
    ! M# K3 w& d6 M% i
  6.     MsgBox "被输入的角度是" & retOrientation & vbCrLf & "(输入下一个值而不提示。)", , "GetOrientation 示例"
    & a/ B2 F0 t% ~3 I0 D3 L) P  }/ P
  7.     ' 无提示返回弧度方向
    + {, m. ~0 l4 W. e1 y' _, [% F1 r
  8.     retOrientation = ThisDrawing.Utility.GetOrientation()
    * _2 q. M" v3 ?6 c9 \8 T# {7 k
  9.     '也可以通过点选两个点来产生直线的角度,同样以起点为准逆时针旋转至终点的角度4 W' W3 a0 M5 K* l+ o
  10.     MsgBox "被输入的角度是:" & retOrientation, , "GetOrientation 示例"
    4 Y! g# V+ Q; D- b! v0 g
  11.     ' 返回带有提示和方向基点的以弧度表示的方向
    6 G) `" z4 N- u# R' g
  12.     Dim basePnt(0 To 2) As Double  y1 L# O1 ^1 ^( S) h/ z
  13.     basePnt(0) = 2#: basePnt(1) = 2#: basePnt(2) = 0#
    0 T) y: a0 f8 Y0 F
  14.     retOrientation = ThisDrawing.Utility.GetOrientation(basePnt, "请输入一个角度: ")) ]9 n/ X; _3 v( V' i/ I6 [% _
  15.     MsgBox "输入的角度是:" & retOrientation, , "GetOrientation 示例"
    / W9 g8 ?! V' o
  16. End Sub
复制代码

% ]( t( X! x: y! e
N.GetPoint方法
RetVal = GetPoint([Point][, Prompt])
PointVariant[变体] (三元素双精度数组); 仅用于输入; 【可选项】指定相对基点的三维 WCS 坐标。
PromptVariant[变体] (字符串); 仅用于输入; 【可选项】提示用户输入的文本信息。
RetValVariant[变体] (三元素双精度数组)AutoCAD 用户选择的点的三维 WCS 坐标。
说明
AutoCAD 暂停,等待用户输入一个点,将选择点的坐标值设为返回值。Point 参数指定的在WCS中的相对基点。Prompt 参数指定了AutoCAD在暂停前显示的字串。Point 和 Prompt 都是可选项。
AutoCAD 用户可以通过输入一个当前单位格式的坐标点来指定一个点;GetPoint 将 Point 参数及返回值作为三维点。用户也可以通过在图形屏幕上指定一个位置来确定一个点。如果提供了 Point 参数,AutoCAD 将从该点到当前十字光标处画一条橡皮筋线。存储在返回值中的点坐标根据 WCS 来表示。
如果返回一个关键字而不是点,AutoCAD 将生成错误信息“用户输入关键词”。用 GetInput 方法可以获得返回值中的关键字。
  1. Sub GetPoint方法()
    + j. m3 O- `! Q4 w& R" a: h
  2.     ' 此示例返回用户输入的点的坐标。: j; r# S6 N0 u3 \+ D
  3.     Dim returnPnt As Variant
    / J" D8 |4 K1 ?) z" g
  4.     ' 使用提示返回点
    7 u- Z) l  l* K7 k. O6 b1 q
  5.     returnPnt = ThisDrawing.Utility.GetPoint(, "选择/输入一个点: "): W% y% p3 ^- t- U9 G. E
  6.     MsgBox "WCS点坐标是: " & returnPnt(0) & ", " & returnPnt(1) & ", " & returnPnt(2) & vbCrLf & _
    0 N3 @6 P7 W1 \( G& [3 l/ ^/ A
  7.             "(不带提示的输入下一个点.)", , "GetPoint 示例"
    7 h5 U. `( C) H5 C0 l
  8.     ' 不带提示的输入下一个点
    # Q7 g. }. T* `  d
  9.     returnPnt = ThisDrawing.Utility.GetPoint
    : ]3 ~' ?. f) i* W* t
  10.     MsgBox "WCS点的坐标是: " & returnPnt(0) & ", " & returnPnt(1) & ", " & returnPnt(2), , "GetPoint 示例"
    7 `5 w' D  e9 m- S0 i( U2 O
  11.     ' 使用基点和提示返回点
    ) M. `( H0 B1 a
  12.     Dim basePnt(0 To 2) As Double! h4 O9 T, ]& e. v: _+ V7 d+ w
  13.     basePnt(0) = 2#: basePnt(1) = 2#: basePnt(2) = 0#
    ! ]0 S" {7 i( y- {
  14.     returnPnt = ThisDrawing.Utility.GetPoint(basePnt, "Enter a point: ")
    5 m9 {7 y8 b' @& x$ V8 c2 ^1 p* l
  15.     MsgBox "WCS点的坐标是: " & returnPnt(0) & ", " & returnPnt(1) & ", " & returnPnt(2)
    2 G' j$ N/ d% J8 q: h
  16.     ' 从基点和输入的最后一个点创建一条线* k8 o$ P5 \% z" [
  17.     Dim lineObj As AcadLine
    " [; b* H$ ^4 Y# Q" h
  18.     Set lineObj = ThisDrawing.ModelSpace.AddLine(basePnt, returnPnt)
    ) W# e* K* `1 S; b" Z* C; Y% k# G
  19.     Update: I8 I: E+ ~0 R, y* g: w& q- P1 T
  20. End Sub
复制代码
* E% E* G5 C) w" ^+ \: b+ D
此示例中并没有显示出基点的作用啊!。。。。。。。。。。。2 r$ Y- b! [1 U) Y9 V
 楼主| 发表于 2019-3-29 20:51:46 | 显示全部楼层
O.GetReal方法
RetVal = GetReal([Prompt])
PromptVariant[变体] (字符串); 仅用于输入; 【可选项】用来提示用户输入的文本信息。
RetValDouble[双精度] 用户返回的值。
说明
AutoCAD 暂停,等待用户输入一个实数值,并将用户输入的值设为返回值。Prompt 参数指定 AutoCAD 在暂停前显示的字串,它是可选项。
如果返回的是关键字,而不是实数。AutoCAD 将生成错误信息“用户输入关键词”。用 GetInput 方法可以从返回值中获得关键字。
  1. Sub GetReal方法()6 X/ E, ^2 i6 K- {' k, h% S, g
  2.     ' 此示例从用户处获取一个实数值
    ! [: j8 A! [# x' A1 W8 l
  3.     Dim returnReal As Double7 m' b. c: H+ D% X, J+ D: W' c
  4.     ' 返回用户输入的值。提供提示.
    . E/ M) b9 R% x( T% R4 }" J( _1 u  t
  5.     returnReal = ThisDrawing.Utility.GetReal("请输入一个实数值: ")- J* ~7 B  W  i% \& b! B; ?
  6.     MsgBox "输入的实数值是" & returnReal & vbCrLf & _( |& [8 p! P' ~$ b# ]: ]! W
  7.             "(不带提示的输入下一个实数值.)", , "GetReal 示例"
    4 N( V4 U3 [2 e) p3 T
  8.     ' 不带提示的输入下一个值
    + e$ E# R+ A1 `- O. z" l- G
  9.     returnReal = ThisDrawing.Utility.GetReal()4 N3 z- K. O+ f) ^2 E
  10.     MsgBox "输入的实数值是:" & returnReal, , "GetReal 示例"
    % L8 a8 r. {- b/ d7 u
  11. End Sub
复制代码
9 z4 h5 c! M, H, H- Y' P  x% j

6 H& D0 R8 w; G# M; \: Q  i4 M
P. GetRemoteFile方法
object.GetRemoteFile URL, LocalFile,IgnoreCache
URLString[字符串]; 仅用于输入,需下载的文件的URL
LocalFileString[字符串]; 仅用于输出,在指定URL上的文件。
lgnoreCacheBoolean[布尔值]
TRUE: 即使文件已经在进程中传输也进行下载。
FALSE: 如果文件已经在进程中传输则不进行下载。
示例暂无!
Q.GetString方法
RetVal = GetString(HasSpaces[, Prompt])
HasSpacesInteger[整数]; 仅用于输入
TRUE: 返回的字符串可以包含空格。它只能以回车键为结束。
FALSE: 返回的字符串不可以包含空格。它可以以回车键或空格为结束。
PromptVariant[变体] (字符串); 仅用于输入; 【可选项】提示用户输入的文本信息。
RetVal字符串,用户返回的字符串。
说明
AutoCAD 暂停,等待用户输入一个字符串,并将用户输入的值设为返回值。HasSpaces 参数指定了字符串是否可以包含空格。Prompt 参数指定了该方法在 AutoCAD 暂停前显示的字符串。
AutoCAD 用户可以通过键盘输入字符串。如果 HasSpaces 参数是TRUE,字符串中可以包含空格,用户必须按回车结束。如果 HasSpaces 参数是False,输入空格或回车都可以结束字符串的输入。如果用户输入多于132个字符,字符串的输入仍可继续直到用户输入一个空格或回车键(根据 HasSpacesd 而定),但是 GetString 只将前132个字符作为返回值。
  1. Sub GetString方法()
    / X" ^7 w9 c$ Q' x- X1 a
  2.     ' 这个例子演示了返回用户输入的字符串的不同方法。
    ( q6 p, G0 g0 i
  3.     Dim returnString As String! P' H0 J1 F$ x6 P+ x) k0 U
  4.     '提示输入,不能包含空格% D! k+ r- a  e0 ~$ I
  5.     returnString = ThisDrawing.Utility.GetString(False, "输入文本(空格或<enter>终止输入): ")
    ' n8 U1 t- h7 t# n
  6.     MsgBox "输入的文本是:'" & returnString & "'", , "GetString 示例"- _& i3 j6 u/ o) e1 O. D
  7.     ' 提示输入,可以包含空格, l/ [5 D( @4 H; Z9 e9 v
  8.     returnString = ThisDrawing.Utility.GetString(True, "输入文本(按<enter>终止输入):")
    . q& D3 @6 z3 k9 C
  9.     MsgBox "输入的文本是:'" & returnString & "'", , "GetString 示例"! ^* E% h$ G: R0 @
  10.     ' 提示和输入可以包含空格,但不能包含空字符串+ |3 p; N1 L2 J+ Z0 s: r
  11.     Dim NoNull As Integer- x! o1 R; \$ ]1 R' C% F
  12.     NoNull = 1    '不允许不输入字符1 X% V1 A8 o, m, m: p4 Z9 M1 P, a
  13.     ThisDrawing.Utility.InitializeUserInput NoNull
    ; C% ~' {$ ^. }5 A+ ~0 T4 t+ w
  14.     returnString = ThisDrawing.Utility.GetString(True, "输入文本(按<enter>终止输入): ")3 K9 `- D' z7 E  a  i5 t
  15.     MsgBox "输入的文本是:'" & returnString & "'", , "GetString 示例"
    : F' e9 h- h* T- x  _- x( o$ U
  16. End Sub
复制代码

; R/ Q7 B, g5 K0 R+ ?; p% `2 Y- R3 y' T) x) ~' v' {$ ~: r
 楼主| 发表于 2019-3-29 20:53:48 | 显示全部楼层
R.GetSubEntity方法
object.GetSubEntity Object, PickedPoint, TransMatrix,ContextData[, Prompt] 以交互方式获取对象或子图元。
ObjectObject[对象]; 仅用于输出,被选取的对象或子图元。可以是任何一个图形对象。
PickedPointVariant[变体] (三元素双精度数组); 仅用于输出,选取点的三维 WCS 坐标。
TransMatrixVariant[变体] (4x4 双精度数组); 仅用于输出,该图元的转换矩阵。
ContextDataVariant[变体] (长整数数组); 仅用于输出,被选取对象中所有嵌套对象的对象ID的数组。
PromptVariant[变体] (字符串); 仅用于输入; 【可选项】提示用户输入的文本信息。
说明
该方法需要 AutoCAD用户通过在图形屏幕上拾取一个点来选择一个对象。如果一个对象或子图元被选中,它将在第一个参数中返回,第二个参数将包含拾取点的 WCS 坐标值。如果拾取点处没有对象,则该方法失败。该方法甚至可以获取在屏幕上不可见或它在冻结层里的对象。
  1. Sub Example_GetSubEntity(): P3 [" z0 k8 ~3 ?8 L
  2.     '此示例提示用户单击鼠标选择屏幕上的对象,并返回有关所选对象的一些信息。! K! v" e8 K; e2 y
  3.     Dim Object As Object! |& p2 w4 B3 {
  4.     Dim PickedPoint As Variant, TransMatrix As Variant, ContextData As Variant
    + a8 H4 {  Y" ]: R  k
  5.     Dim HasContextData As String. K/ B) l' ~# Z  j& ?$ j7 R- F
  6.     On Error GoTo NOT_ENTITY' \& ^6 G# P! H( q7 c5 b% @
  7. TRYAGAIN:
    5 o/ ?- f1 g% i* Q
  8.     MsgBox "取消此对话框后,使用鼠标单击当前图形中的对象。"
    6 X0 G$ R: N+ c9 N6 d0 e! F+ r# F  z
  9.     '获取所选对象的信息
    * x8 @+ e% W' j
  10.     ThisDrawing.Utility.GetSubEntity Object, PickedPoint, TransMatrix, ContextData
    1 x: U9 C- B2 q! f$ e$ {  E' ^6 Z
  11.     ' 处理和显示所选对象属性
    ( ]3 p6 p0 h6 n3 U
  12.     HasContextData = IIf(VarType(ContextData) = vbEmpty, " 不包含 ", " 包含 ")
    / f; X: ]; [" g3 S
  13.     MsgBox "你选择的对象是: " & TypeName(Object) & vbCrLf & _
    + k' r* l6 {2 s
  14.         "你选择的点坐标是: " & PickedPoint(0) & ", " & _4 ^) ]8 S, k! S0 P
  15.         PickedPoint(1) & ", " & _
    9 ?; r7 l; t+ S- k! @% A, m# H
  16.         PickedPoint(2) & vbCrLf & _
    7 T, x( ^4 ]! `2 [) }: w4 F; m# a: J
  17.         "所选对象" & HasContextData & "有嵌套对象."
    0 H5 e7 F2 b# l0 C
  18.     Exit Sub; k9 F; D1 L+ [5 }4 S
  19. NOT_ENTITY:
    0 {% h( o% _1 P% I
  20.     '如果单击空白空间或不选择实体,将生成此错误6 p8 V. F  e8 ~* N/ M
  21.     If MsgBox("你未选择对象实体.  单击“确定”重试.", _5 ?7 ^* x4 ^8 L# R% T
  22.         vbOKCancel & vbInformation) = vbOK Then2 ~" V* A8 a9 S" L: E
  23.         Resume TRYAGAIN
    ; s, A8 L- |  S2 y0 w" _0 k9 a& v
  24.     End If" ]. a" \7 \5 L; M' X( ~; R$ K+ o
  25. End Sub
复制代码

) x4 n. X# q+ t  i9 K/ j3 K$ H3 B

/ J% I- @7 j0 L* f5 v* \4 x  H

8 v: W: D0 x) `) U( C
S.InitalizeUserInput方法
object.InitializeUserInput Bits[, Keyword]      初始化 GetKeyword 方法。
BitsInteger[整数]; 仅用于输入
要同时设置多个条件上,可把这些值相加做任意组合如果不包含这些值或设为 0,则不使用这些控制条件。
1 :不接受 NULL 输入。防止用户只按回车或空格来响应输入请求。
2:不接受输入零值(0)。防止用户输入 0 来响应输入请求。
4:不接受输入负值。防止用户输入负值来响应输入请求。
8:即使 LIMCHECK 系统变量为打开时也不检查图形界限。使用户能够输入当前图形界限以外的点。即使 AutoCAD 的系统变量 LIMCHECK 当前被设置为开 (ON),本条件也照样对随后调用的用户输入函数有效。
16:目前不使用。
32:用虚线绘制拖引线或拉伸方框。对于那些可以由用户在图形屏幕上通过选择位置来指定一个点的函数,设置该控制位将使拖引线和拉伸方框显示为虚线而不是实线(某些显示驱动程序用颜色醒目的线来代替虚线)。如果系统变量 POPUPS 设为 0AutoCAD 将忽略该控制位。
64:忽略三维点的 Z 坐标(只用于GetDistance 方法). 该项忽略由 GetDistance 方法返回的三维点的 Z 坐标,以使应用程序确保该函数返回的是二维距离。
128:允许任意输入任何用户类型。
KeyWordVariant[变体] (字符串数组); 仅用于输入; 【可选项】将被后续的用户输入方法识别的关键字。
说明
在调用GetKeyword 前必须用该方法定义关键字。假如已经调用该方法定义了关键字,请确定用户输入方法可接受正常返回值以外的关键字值。可接受关键字的用户输入方法有:GetKeyword, GetInteger, GetReal, GetDistance, GetAngle,GetOrientation, GetPoint, 和 GetCorner。
示例暂略!
T.IsRemoteFile方法
RetVal = object.IsRemoteFile(LocalFile,URL)
LocalFileString[字符串]; 仅用于输入下载的文件。
URLString[字符串]; 仅用于输出下载的文件的URL (如果有)
RetValBoolean[布尔值]
TRUE: 文件从远程位置下载。
FALSE: 文件不从远程位置下载。
说明
该方法与 IsURL 方法相反,它提供了从本地文件到下载的文件所对应的 URL 映射。
示例暂略!& x  s7 G* o. Y% I
 楼主| 发表于 2019-3-29 20:55:38 | 显示全部楼层
U.IsURL方法
RetVal = object.IsURL(URL)
URL: String[字符串]; 仅用于输入所要验证的URL
RetValBoolean[布尔值]
TRUE: 字符串为有效的 URL。
FALSE: 字符串为无效的 URL。
说明
“无效”的 URL 定义与应用程序有关,在这里给定的第三方应用程序可能对支持所有 Internet 协议不感兴趣。例如,一个应用程序试图连接用户到网站而不需要提供访问到 FTP 站点。在这种假定的应用程序中,如果 URL 不是以“http://”开头,将返回 FALSE。
该方法默认的功能支持 FTPHTTPHTTPS FILE 协议。
示例暂略!
V.LaunchBrowserDialog方法
启动 Web 浏览器窗口,允许用户导航到任意 URL 并可指定 URL。暂略!
W.PolarPoint方法
RetVal = PolarPoint(Point, Angle, Distance)   获取与给定点指定角度和距离的点坐标。
PointVariant[变体] (三元素双精度数组); 仅用于输入指定起点的三维WCS坐标。
AngleDouble[双精度]; 仅用于输入以弧度为单位的角度值。
DistanceDouble[双精度]; 仅用于输入以当前单位为单位的距离值。
RetValVariant[变体] (三元素双精度数组)该三维WCS的坐标是根据相对给出点的距离和角度得到的坐标。
  1. Sub PolarPoint方法()
    $ l/ U9 o; G% B9 y
  2. '此示例查找与基点之间给定距离和角度的点的坐标。7 c5 `, K. v% e8 I
  3.     Dim polarPnt As Variant
    3 Y$ r8 S2 ^( G4 e0 A# s
  4.     Dim basePnt(0 To 2) As Double
    2 `. E( x9 R- h. N; ?1 e
  5.     Dim angle As Double2 Q+ O& ?0 G' S6 N- a5 Z( K  _
  6.     Dim distance As Double6 n* U$ a. Q/ d* _4 s  `  Y
  7.     basePnt(0) = 2#: basePnt(1) = 2#: basePnt(2) = 0#3 L* f; v# i9 S
  8.     angle = 3.1415926 / 2 ' 90 degrees. _6 O: z0 g1 e1 L& F- _
  9.     distance = 50 l2 @% D- ~& k4 T
  10.     polarPnt = ThisDrawing.Utility.PolarPoint(basePnt, angle, distance)! E3 |5 O( p: G' R
  11.     ' 从基点到选择点之间画一条直线1 B- v9 o: a, O- L
  12.     Dim lineObj As AcadLine
      W9 B  `7 K/ o: t# ^& x5 ^
  13.     Set lineObj = ThisDrawing.ModelSpace.AddLine(basePnt, polarPnt)
    1 B# `1 h% [' j# g" D' j  \
  14.     ZoomAll! U* g6 l. Z0 A0 l
  15. End Sub
复制代码

0 a- H# J8 _/ Q" X
X.Prompt方法
object.Prompt Message
MessageString[字符串]; 仅用于输入要显示的提示内容。
Sub Example_Prompt()
'此示例将使用实用程序对象向AutoCAD命令行显示提示。要在运行示例后查看结果,请切换到AutoCAD并查看命令行。
   ThisDrawing.Utility.Prompt "L 0,0 100,100  "   '只是在命令行显示字符串,并不能发送命令绘图!
End Sub
Y.PutRemoteFile方法
object.PutRemoteFile URL, LocalFile
URLString[字符串]; 仅用于输入指定要上传文件的 URL 位置。
LocalFileString[字符串]; 仅用于输入要上传的文件。
说明
该方法是为了完善GetRemoteFile 方法来设计的。
当连接到一个安全的URL后,会弹出一个对话框提示用户输入必要的密码信息。如果用户没有在其浏览器中抑制该行为,则会出现消息框。
示例暂略!' M5 s& A, {3 L, J- n% W. P, _( e
 楼主| 发表于 2019-3-29 20:57:23 | 显示全部楼层
本帖最后由 kuangben8 于 2019-3-29 20:58 编辑
- V& E! J3 J" d: d; Q# x$ B: B/ d
4 _; d5 q- m5 ?' gZ.RealToString方法
RetVal = RealToString(Value, Unit,Precision)
ValueDouble[双精度]; 仅用于输入要转换的值。
UnitAcUnits 常数; 仅用于输入
acDefaultUnits  默认格式
acScientific     科学计数法格式
acDecimal      十进制格式
acEngineering   工程格式
acArchitectural  建筑格式
acFractional    分数格式
PrecisionInteger[整数]; 仅用于输入值的精度。为 0 8 的整数
RetVal字符串,相应格式的字符串值。
  1. Sub RealToString方法()& n( s5 D% {2 M) |
  2.     ' 此示例将给定格式的值转换为等效的字符串。
    5 }' \- L6 O, v! ^0 k" P6 P1 p
  3.     Dim unit As Long$ S. y0 G- }) s" X" J9 V8 P7 A
  4.     Dim valueAsStr As String
    ( {& C+ r' e) @( e' i
  5.     Dim precision As Integer
    & H. b8 b$ f( w/ J4 B" p/ E
  6.     Dim valueAsReal As Double
    - }& x7 ?  m' Q, A/ g( n# _; n+ I
  7.     precision = 6! s; M) Y/ L( @% t( \. J$ U
  8.     '使用科学模式将实值17.5转换为字符串# k7 [! n  v! b' w- j
  9.     unit = acScientific) A) u) p' g8 I: h$ Z- ^
  10.     valueAsStr = ThisDrawing.Utility.RealToString(17.5, unit, precision)
    9 j3 D# H, G& \
  11.     MsgBox "17.5科学格式为" & valueAsStr, , "RealToString 示例"5 O1 n  A- i+ t$ e
  12.     ' 使用十进制模式将实值17.5转换为字符串
    3 D7 G0 e% ?: }. O+ V. w5 t- ]/ [
  13.     unit = acDecimal
    ' j8 y8 u$ X4 {. U% q6 T
  14.     valueAsStr = ThisDrawing.Utility.RealToString(17.5, unit, precision)
    0 j+ R7 Y- M$ F. p% T
  15.     MsgBox "17.5十进制格式为" & valueAsStr, , "RealToString 示例"! m% d  y# ^" s* j
  16.     ' 使用工程模式将实值17.5转换为字符串
    4 x4 F. @" j3 E! }1 R, E+ p$ V2 A( Z
  17.     unit = acEngineering0 a) N. f& |) U0 A
  18.     valueAsStr = ThisDrawing.Utility.RealToString(17.5, unit, precision)
    , `# F! m0 W' R/ I) K
  19.     MsgBox "17.5工程格式为" & valueAsStr, , "RealToString 示例"/ C* S) O* _' y& f
  20.     ' 使用体系结构模式将实值17.5转换为字符串
    . G" w0 I) N" m( A) |
  21.     unit = acArchitectural+ A9 O4 R6 C' }
  22.     valueAsStr = ThisDrawing.Utility.RealToString(17.5, unit, precision)
    3 w/ s: A1 |+ p+ ?* M+ X9 T2 s
  23.     MsgBox "17.5建筑形式为" & valueAsStr, , "RealToString 示例"
    6 }# N4 h, B0 q  a
  24.     ' 使用分数模式将实值17.5转换为字符串
    6 e' a) l0 d' e+ n+ z- R
  25.     unit = acFractional9 x9 `& @& d0 m, i# I4 }" p. R
  26.     valueAsStr = ThisDrawing.Utility.RealToString(17.5, unit, precision)9 e9 p$ M# W- T5 L$ V$ |, W
  27.     MsgBox "17.5分数格式为" & valueAsStr, , "RealToString 示例"# A- M) X7 F0 a' Y# P
  28. End Sub
复制代码

7 [1 X' C% c. s% @( S( q8 n( f' a
AA.SendModelessOperationEnded方法
object.SendModelessOperationEnded(Context)
AB.SendModelessOperationStart方法
object.SendModelessOperationStart(Context)
AC.TranslateCoordinates方法
RetVal =object.TranslateCoordinates(OriginalPoint, From, To, Disp[, OCSNormal])  将点从一个坐标系转换到另一个坐标系。
OriginalPoint Variant[变体] (三元素双精度数组); 仅用于输入指定要转换的源坐标的三维 WCS 坐标。该参数可被看为一个点或相对于 Disp 值的位移矢量。
FromAcCoordinateSystem 常数; 仅用于输入点的源坐标系,有如下参数。
acWorld          acUCS         acOCS         acDisplayDCS       acPaperSpaceDCS
ToAcCoordinateSystem 常数; 仅用于输入点将被转换到的坐标系。
acWorld         acUCS         acOCS         acDisplayDCS        acPaperSpaceDCS
DispInteger[整数]; 仅用于输入位移矢量标记
TRUE: OriginalPoint 作为位移矢量。 FALSE: OriginalPoint 作为一个点。
OCSNormalVariant[变体] (三元素双精度数组); 仅用于输入;可选项OCS 的法线。
RetValVariant[变体] (三元素双精度数组)转化后的三维坐标。
说明
用户不能直接将坐标从一个OCS 转换到另一个 OCS。首先将一个坐标从一个 OCS 转换为中间坐标系(如 WCS),然后将其坐标转换为第二个 OCS 。
Polyline LightWeightPolyline 上的点从 OCS 转换到 WCS
1. Coordinate Coordinates属性中获得 OCS 点的 X Y 坐标。
2. 通过 Elevation 属性获得 OCS 点的 Z 坐标。
3. Normal 属性中获得样条曲线的法线。
4. X, Y, Z 坐标及 Normal 调用TranslateCoordinates
示例暂略!* Q- K8 Y+ j6 o# N6 _" k, g% r5 E
关于Utility对象及其方法示例下载:1 Y+ v' |. f/ C* u0 Y# u) g
2.12、很有用的Utility对象.zip (19.21 KB, 下载次数: 2)
 楼主| 发表于 2019-3-29 21:02:18 | 显示全部楼层
13、使用Utility对象手动辅助绘图示例) U: v9 J+ o, a  L6 V
/ o1 J7 F" K$ m# A6 s$ V
A、手动三点画弧
  1. Sub 手动三点画弧1()
    : h6 D( N; P0 Y  W2 g! ~0 x
  2.     Dim P1 As Variant, P2 As Variant, P3 As Variant, L1 As AcadLine, L2 As AcadLine1 `  L0 W# `6 M
  3.     With ThisDrawing' T( e! m$ h: ^
  4.         With .Utility5 w" B4 e+ Q6 p! M
  5.             P1 = .GetPoint
    & y0 H9 R4 V: ?3 \+ {
  6.             P2 = .GetPoint) ^5 J2 h; F/ S4 `1 a5 w9 x
  7.             P3 = .GetPoint
    0 ]8 O: v! D6 A1 e0 r+ |  \+ L
  8.         End With
    ( ?6 U$ y$ O+ k( s+ C
  9.         Set L1 = .ModelSpace.AddLine(P1, P2)
    + x5 n: a7 X$ |8 Z9 K( v: g
  10.         Update- H$ V2 B% V/ a8 T' {1 j2 n
  11.         Set L2 = .ModelSpace.AddLine(P2, P3)
    3 f/ {7 [6 j! t4 l. o  a" E
  12.         Update& `: @0 b6 h) i$ ?  w# N
  13.         L1.StartPoint = .Utility.PolarPoint(L1.StartPoint, L1.Angle, L1.Length / 2)   '将L1起点坐标修改为L1中点坐标
    $ a; F  i1 p6 R2 d  z
  14.         Update
    ( {3 x0 f. k) z) m( b: X; {1 u# \
  15.         L1.Rotate L1.StartPoint, .Utility.AngleToReal(90, acDegrees)                  'L1绕新起点旋转90°(将90转换为弧度)  W# D& c" _/ ]6 c% F
  16.         Update6 b" e- N+ M3 O; q
  17.         L2.StartPoint = .Utility.PolarPoint(L2.StartPoint, L2.Angle, L2.Length / 2)   '将L2起点坐标修改为L2中点坐标
    ) y& `1 c$ A! c7 N2 o, y! Y- N7 ~
  18.         Update. |; \, F1 O/ u/ e8 I
  19.         L2.Rotate L2.StartPoint, .Utility.AngleToReal(90, acDegrees)                  '同样将L2绕新起点旋转90°! u2 g; Q" X7 z+ B9 r% O6 f' E
  20.         Update
    , r/ G* V2 m. M8 M
  21.         L1.StartPoint = L1.IntersectWith(L2, acExtendBoth)      '将L1起点修改为L1和L2相交的交点坐标(双方都延伸),也就是圆心。; H7 M/ q/ Z- G1 E+ Z- b0 k. @
  22.         Update
    / k6 ~, @  o9 k* [/ K# c  r$ f
  23.         L1.EndPoint = P1
    / v2 S# \9 W3 y6 {5 x# k8 d
  24.         Update
    3 [% q  |) d& G) R3 n1 x  J
  25.         L2.StartPoint = L1.StartPoint     'L2的起点坐标修改为L1的起点坐标,也就是圆心处。( w) @8 h% M+ K9 T" R5 k: V) c
  26.         Update
    . G4 e3 [: @- b) g: J
  27.         L2.EndPoint = P3' f/ v3 n8 x1 O/ q* A
  28.         Update* }- T5 V* u  N( w& o* |# N
  29.         .ModelSpace.AddArc L1.StartPoint, L1.Length, L1.Angle, L2.Angle
    ! v+ ~! n, f- U$ [: [6 u! i
  30.         Update; E* N. f! i8 C, ^& O- f
  31.         .ModelSpace.AddArc L1.StartPoint, L1.Length, L2.Angle, L1.Angle
    ) B; J5 w& `' \8 A! f* m4 a
  32.         Update
    6 Z$ s# Z2 [$ F
  33.         L1.Delete- G/ S; q" W- Y8 Z4 n
  34.         Update
    7 F; a8 c, a1 N" `" t, D1 p; r& c
  35.         L2.Delete# Q0 A, h, F' L
  36.         Update
    % o1 w: i# S  u" u( @: V1 `
  37.     End With1 z6 o# s6 {/ D! v
  38. End Sub
复制代码
0 O7 |; |3 [0 ?3 I6 k% F
B、手动三点画圆
类似手动三点画弧,因此没有想到其他解法时暂略重复代码!
" `2 ~, j8 k, o4 F( A% X5 W: C. g; L' {
C、手动两点半径画弧
  1. Sub 手动两点半径画弧()
    ; z. k/ D; P- Y( y7 d$ z0 d  K9 S3 K
  2.     Dim P1 As Variant, P2 As Variant, R As Double, L As AcadLine, ARC As AcadArc
    8 y/ T9 D# ?0 ?& e# |( m
  3.     With ThisDrawing- K# H' {. K/ s* B
  4. X:! T' w4 p! F1 U+ g: I5 [
  5.         With .Utility
    6 |, Q3 F/ I. f2 R
  6.             P1 = .GetPoint
    ) h6 @( }: H5 ?" m3 P) t) U7 \
  7.             P2 = .GetPoint& l! ]' t4 I, f, p( W
  8.             R = .GetReal("请输入圆弧半径(Double类型)")
    " V+ s  x% f8 R$ B2 K4 C# w/ I
  9.         End With
    $ x4 A0 p8 Q' z* @' c2 N. e- s
  10.         Set L = .ModelSpace.AddLine(P1, P2)
    : E' k: }9 |2 E1 [( ?/ `5 p
  11.         Update
    5 S7 ^+ M1 X9 ]1 |% T
  12.         Dim FirstAngle As Double, EndAngle As Double
    # r- D$ _, O+ m
  13.         If L.Length > 2 * R Then3 V4 g0 I: ^+ E7 H, d% @+ q
  14.             If MsgBox("输入的两点距离大于半径的2倍,无法画弧,请重新输入!", vbYesNo + vbInformation, "AutoCAD友情提示") = vbYes Then
    ' c$ z5 V$ M$ A  s2 x3 ]+ j$ R
  15.                 GoTo X
    / {7 |3 ?, o+ e2 r3 \6 J7 b& H
  16.             Else) q! M' Z5 ]7 b9 ?; `7 o* m
  17.                 Exit Sub( }' t0 ^! \' K, G
  18.             End If
    3 m& X9 C: K, f) P+ v
  19.         ElseIf L.Length = 2 * R Then
    0 c6 ^; E0 R! i% U# `5 P6 ^, ~4 Q
  20.             Dim P0 As Variant
    ' [  N+ \0 D. t& f/ f" w
  21.             With .Utility: }6 C! z1 Z& L! o; y
  22.                 P0 = .PolarPoint(P1, L.Angle, L.Length / 2)     '获取圆心坐标
    6 @- x: V  t( c9 f  a: G
  23.                 FirstAngle = .AngleFromXAxis(P0, P1)            '获取起始角弧度
    / o1 C2 ~" ]2 [' ^
  24.                 EndAngle = .AngleFromXAxis(P0, P2)              '获取终止角弧度1 P6 U; _2 H8 U
  25.             End With5 b8 H) D4 O2 _7 {2 b
  26.             Set ARC = .ModelSpace.AddArc(P0, R, FirstAngle, EndAngle)
    * X7 O1 t  F0 h4 J! F
  27.             Update* m& T- a3 Q3 X) H: _6 T6 n9 i" Z
  28.         Else
    ( V1 H; L' U& r* Z( U. x8 q
  29.             Dim P01(2) As Double, P02(2) As Double, cir1 As AcadCircle, cir2 As AcadCircle
    6 R% q% x8 T9 l
  30.             Set cir1 = .ModelSpace.AddCircle(P1, R)
    5 B+ S$ m9 x- D4 ]( M6 ^) n. ]3 V; x2 {
  31.             Set cir2 = .ModelSpace.AddCircle(P2, R)3 W# g. C8 ?; }: a1 e1 C
  32.             P01(0) = cir1.IntersectWith(cir2, acExtendNone)(0)      '第一个圆心坐标
    # I! E$ W4 Y, w$ }$ O
  33.             P01(1) = cir1.IntersectWith(cir2, acExtendNone)(1)
    % k6 @, D; q# R, S
  34.             P02(0) = cir1.IntersectWith(cir2, acExtendNone)(3)      '第二个圆心坐标
    7 r' C& t2 t' n! K: f. |! t- S
  35.             P02(1) = cir1.IntersectWith(cir2, acExtendNone)(4)% U( b  d/ |# e6 Y# u
  36.             With .Utility
    1 [$ E9 y! X1 ]  s" y
  37.                 FirstAngle = .AngleFromXAxis(P01, P1)
    + r$ H9 \; z! ~" u. c
  38.                 EndAngle = .AngleFromXAxis(P01, P2)8 f( ^4 q5 d) \6 q
  39.             End With
    / a4 F0 W. W/ Q2 o# M
  40.             Set ARC = .ModelSpace.AddArc(P01, R, FirstAngle, EndAngle)
    9 z6 M5 r* I* U" Y
  41.             Update
    $ N# |7 U1 N5 g6 F( _9 M
  42.             % T9 V- o# j1 G- L
  43.             With .Utility0 N( n# m) [, o
  44.                 FirstAngle = .AngleFromXAxis(P02, P1)
    + P5 B4 @# Y% `9 B2 b
  45.                 EndAngle = .AngleFromXAxis(P02, P2)3 B: D$ T% i! F& C- k, s- i
  46.             End With
    - O) `9 y/ P& N& V2 f
  47.             Set ARC = .ModelSpace.AddArc(P02, R, FirstAngle, EndAngle)% q7 l0 M& D' {- y/ I; j0 H: _
  48.             Update
    . M4 w/ v7 U" K8 f
  49.         End If3 g: q6 P( i7 D! r8 `
  50.         cir1.Delete: n- A4 D! K: l! p) X
  51.         cir2.Delete
    . A2 B3 m; x/ x# T" L
  52.     End With
    $ g3 K0 b' T, \4 V% Y8 J
  53. End Sub; `1 s. g3 A( C- u% m
复制代码
6 R# i4 E" V5 @- T) Y

: i- Z% [3 W3 K( b! v 2.13、利用Utility对象方法画图.zip (7.87 KB, 下载次数: 2)
 楼主| 发表于 2019-3-29 21:05:22 | 显示全部楼层
14、手动取点画图时添加提示线# a* y! e$ I9 v: V9 t3 l) g& N! [0 V

2 v1 D- A; x3 P8 N" t
想要在绘图时根据手动取点后,在上一点和下一点之间显示一条弹性线并有提示,在使用Utility对象的相关方法时,参数中的基点坐标不可省略!含有Prompt的方法均写上即可
A、手动画一条直线
  1. Sub 画直线()
    % m0 ]0 _% C( _$ n1 H
  2.     Dim P1 As Variant, P2 As Variant, L As AcadLine
    5 P+ U, t$ z5 ~  k6 q% E3 G/ C$ E3 c
  3.     With ThisDrawing
    / Z3 a9 ~# g) g1 Z9 E
  4.         With .Utility
    4 S) e0 l9 Q, \- _: R
  5.             P1 = .GetPoint(, "请选择第一个点的位置")
    7 E! S: O4 k7 p& d& y
  6.             P2 = .GetPoint(P1, "请选择第二个点的位置")    '在第一个点和鼠标之间会有一个随鼠标移动的弹性线9 Y6 w+ m  x" V5 s
  7.         End With
    ) T! ~5 u0 q) }! X: k  Q' f
  8.         Set L = .ModelSpace.AddLine(P1, P2)
    # d2 O3 D% \4 m/ w5 E8 h
  9.     End With/ j* L+ k) B5 U& @+ I2 f+ r. y
  10. End Sub
复制代码

8 M. g8 A5 N  @5 c" |  `
B、手动画圆
  1. Sub 画圆()7 d' g+ u4 b( T' p2 I( A
  2.     Dim P0 As Variant, R As Double, cir As AcadCircle
    & D9 A3 g, c6 s
  3.     With ThisDrawing( e/ M) S7 v4 ^/ b
  4.         With .Utility
    1 C: {5 v+ `" K: b# x4 z
  5.             P0 = .GetPoint(, "请选择圆心所在位置")" q- R6 H+ r* U2 @
  6.             R = .GetDistance(P0, "请输入圆的半径")  '以P0为基点,可以输入距离或者点击下一点) T3 N3 h0 e& t, n  N3 o) H
  7.         End With
    - b) |  R. I8 E  _
  8.         Set cir = .ModelSpace.AddCircle(P0, R); f( K( G2 d' N  G: z) x
  9.         '以上写法只能实现在屏幕上出现提示信息和提示线,不会产生随鼠标动的圆5 |: T* P% t8 y( K# u% V0 i) K
  10.         Set cir = .ModelSpace.AddCircle(P0, .Utility.GetDistance(P0, "请输入圆的半径"))' y" w7 x+ u6 c5 k; _. P
  11.         '同上,似乎不能产生随鼠标动的圆,需要用到LISP语言才有这个效果!% Y1 ~, L/ \2 ]: b0 N7 w
  12.     End With  A- ^4 T0 ^3 ?' A# ]+ o
  13. End Sub
复制代码

) m3 F, v8 b; o# E1 Z/ j& u& ]  a
想要产生如同图形界面画图那样的生动效果,还是需要采用LISP语言比较合适.
2.14、手动绘图时添加提示信息及提示线.zip (5.56 KB, 下载次数: 2)
 楼主| 发表于 2019-3-29 21:08:45 | 显示全部楼层
本帖最后由 kuangben8 于 2019-3-29 21:09 编辑 # a6 b' |. x( m- e+ n
$ U: Q- }4 P8 h
15、样条曲线对象(SpLine)
3 \( X  l- W; q3 _' Q
$ [7 N8 K0 s6 I1 B! c
A、添加样条曲线方法(AddSpline)
RetVal = object.AddSpline(PointsArray,StartTangent, EndTangent)
PointsArray: Variant[变体] (双精度数组); 用于输入定义样条曲线的三维WCS坐标数组。至少需要两个点(六个元素)来构成 Spline 对象。并且样条曲线始终以该数组的每三个元素为一个点的坐标,因此该数组大小必须为3的倍数若不指定元素值,默认坐标均为0
StartTangent: Variant[变体] (三元素双精度数组); 用于指定与样条曲线第一点相切的三维坐标。
EndTangent: Variant[变体] (三元素双精度数组); 用于指定与样条曲线最后一点相切的三维坐标。
关于此二参数的说明: 一组三维坐标代表一个点,与第一个点或最后一个点组成的直线方向就是对应起点或终点的切线方向;以起点或终点为直线的起点,水平向右为X轴,逆时针旋转至三维坐标点所在处的角度就是切向角。如果三维参数都是0,就是不指定方向(用CAD的默认方向)。3 j1 g! M. ?) ]. `% ]+ H2 i9 K: d
RetVal:新创建的样条曲线对象。
) J% W$ L6 _9 t! x% f2 y
  1. Sub AddSpline方法()
    ( `/ ?: z. Z, u) O3 g/ S" `
  2.     ' 该示例在模型空间中创建样条曲线对象。
    8 A+ S0 A& k) G1 B6 e4 P
  3.     Dim splineObj As AcadSpline
    ; t0 D8 i5 o& W/ A) ?# B! S
  4.     Dim startTan(0 To 2) As Double
    5 T8 k. S4 N( q0 U
  5.     Dim endTan(0 To 2) As Double
    1 A# p, C8 h, N; b, g
  6.     Dim fitPoints(0 To 8) As Double8 T$ a: P, {+ F/ ~) a
  7.     startTan(0) = 0.5: startTan(1) = 0.5: startTan(2) = 0     ‘第一个点的切向点坐标7 X8 }2 F# X! n' V- F: d" i/ V+ ~* V
  8.     endTan(0) = 0.5: endTan(1) = 0.5: endTan(2) = 0       ‘最后一个点的切向点坐标
    $ c  _' }: T0 X% J& }
  9.     fitPoints(0) = 1: fitPoints(1) = 1: fitPoints(2) = 0
    , v0 x2 i( I, D* w& Y5 ]% c! n5 r* y5 z
  10.     fitPoints(3) = 5: fitPoints(4) = 5: fitPoints(5) = 0( X% V, C2 z( a3 [- t0 d7 ~
  11.     fitPoints(6) = 10: fitPoints(7) = 0: fitPoints(8) = 0
    7 ]9 X9 H4 c: j" F* K; h
  12.     Set splineObj = ThisDrawing.ModelSpace.AddSpline(fitPoints, startTan, endTan)
    1 o% B( @. O3 i3 F% s/ V
  13.     Update
    # n* n* [) g. T1 f% C
  14. End Sub/ j8 \' L) y8 S9 ]0 z: a
复制代码

2 \1 D7 B& Q# b4 d. ?$ z' o0 C9 ~1 j; F) J4 q0 [
B、样条曲线对象(SpLine)的常用方法及属性
常用方法:
Copy、Delete、IntersectWith、Mirror、Move、Offset、Rotate、Update……具体示例略,参考一下Reverse、Offset示例,体会一下Offset的结果是多条样条曲线的情况

# a  a* n8 P0 d* Q/ ~
  1. Sub 样条曲线的常用方法()
    5 `* n* v: x- o& K
  2.     Dim P(299) As Double, SP As AcadSpline$ K7 A: f& c1 k$ W
  3.     Dim startTan(0 To 2) As Double% l. v4 M$ k! n( H* w
  4.     Dim endTan(0 To 2) As Double2 N) S( z8 n; p# ?6 f/ x/ g1 j
  5.     Dim M%
      R8 M4 m+ ]3 T
  6.     Const π As Double = 3.14159265358979% L/ l& \' b1 b  R1 X
  7.     For M = 1 To 100
    1 p+ T0 `$ X7 }
  8.         P(3 * M - 3) = M * 0.1
    1 {: p' h; q) U& Q
  9.         P(3 * M - 2) = Sin(M * π / 10)" U0 O0 y. C; K' ~1 I3 U
  10.         P(3 * M - 1) = 0% A2 H2 Q  \. F
  11.     Next8 w$ g- N" F7 ~+ Y* Y
  12.     startTan(0) = 0: startTan(1) = 0: startTan(2) = 0
    ) J! c6 G1 I6 ?5 I9 |
  13.     endTan(0) = 0: endTan(1) = 0: endTan(2) = 0
      W0 g7 y. f/ @  R
  14.     Set SP = ThisDrawing.ModelSpace.AddSpline(P, startTan, endTan)( n8 U/ x3 j: h2 z: ~. X! u  `9 c
  15.     Update3 P8 a, ^& ~6 Z! [  _4 ^
  16.     Rem 接下来参考反转和偏移示例,其他示例略!
    : `2 ^2 E. t( t3 b" H" w' M. y, L
  17.     Dim pll As AcadSpline, SPL As Variant
    / Y) G" i1 @  D$ t8 |3 L3 l. v
  18.     Set pll = SP.Copy
    2 @$ P0 Q: P7 O: i8 K7 B  G. V& |
  19.     Update0 b! j" P4 _# M
  20.     pll.Reverse     '反转样条曲线的方向:就是将原来的第一点变成最后一点,最后一点变成第一点。
    ' g* b" x  e6 G. ~7 u/ F/ s5 L
  21.     Update% v! _# X7 L5 z/ t' h; X
  22.     SPL = SP.Offset(-0.5)   '正值向下偏移,负值向上偏移6 v6 y$ k. w, w( L4 _/ G0 R
  23.     Update
    ' b8 U/ ?1 J5 |6 s3 z8 M
  24.     SPL(0).color = acCyan  '发现偏移后的结果不在是一条样条曲线,而是多条样条曲线
    - p1 l9 @! I* f" a. J  v
  25.     Update2 p  U4 k/ D6 W1 O) C
  26.     SPL(3).color = acCyan  '发现偏移后的结果不在是一条样条曲线,而是多条样条曲线
    # u8 _+ Z$ U, @/ D
  27.     Update- c3 g9 G* D& v
  28.     SPL(5).color = acCyan  '发现偏移后的结果不在是一条样条曲线,而是多条样条曲线
    ; ^& J  V/ v2 e. G" \
  29.     Update! A# Y3 [. v: }' C- [. f3 b, M
  30. End Sub2 q9 Y+ K  i- v) n0 n
复制代码

+ @! i* c+ G4 G1 b& T% b: I% a2 L8 {/ u% ^% g
常用属性示例
其他简单属性略:重点理解一下样条曲线的起止点的切向矢量:StartTangentEndStantgent
可以理解为另外的一个控制点,这个点相对于样条曲线的起(端)点,用于指示起(端)点的方向。这个点到起(端)点的直线长度是 1 ,比如T(0)=1,T(1)=0,就是0度方向(相对于X轴);T(0)=0.707,T(1)=0.707,就是45度方向(相对于X轴)。T(0)=-0.5,T(1)=-0.866,就是240度方向(相对于X轴)。如果三维参数都是0,就是不指定方向(用CAD的默认方向)。
按照CAD的规定,三维参数的平方和应该是1,不过不是1也行。反正就是按三维坐标算角度。当然,尽量按CAD的要求来,以免意外出错。即用三维坐标指示方向。
4 _$ }( p5 C! O9 c$ t
  1. Sub 样条曲线的常用属性(): K8 c7 s5 Y- p( z7 a
  2.     Dim P(299) As Double, SP As AcadSpline
    ' y( P$ }0 Z; R7 D
  3.     Dim startTan(0 To 2) As Double
    ( N" Y: a; ~5 w
  4.     Dim endTan(0 To 2) As Double
    8 f! p* D  i" j( w
  5.     Dim M%
    1 X$ A  p7 L* h, A7 f/ {
  6.     Const π As Double = 3.14159265358979- l1 g8 j. M) \/ f: }1 e, y
  7.     For M = 1 To 1003 s7 O; f% F9 X5 I' L
  8.         P(3 * M - 3) = M * 0.1& j  M) b3 M' G/ B+ H! m4 N8 \7 l* _
  9.         P(3 * M - 2) = Sin(M * π / 10)
    0 |. g; p( |8 g4 G7 H
  10.         P(3 * M - 1) = 0% r; X( g% w$ ?$ B) U1 Z9 z# c
  11.     Next. I/ t  ~' D9 w1 D5 I
  12.     startTan(0) = 5: startTan(1) = 5: startTan(2) = 0$ N4 ?' A! @8 w- B. \; J8 u7 J! J
  13.     endTan(0) = 10: endTan(1) = 10: endTan(2) = 0
    ( X1 U9 Y: E. n1 t( M+ s! t
  14.     Set SP = ThisDrawing.ModelSpace.AddSpline(P, startTan, endTan)
    & ~2 d# ~& U& S  @
  15.     Update
    % ^; m8 m( o' N) Q7 u
  16.     MsgBox SP.Degree    '不理解这个次数3是怎么定的?- r. h$ s: n' x$ _0 W/ Z) f
  17.     Dim X As Variant& k+ z- o& z. B' l
  18.     X = SP.StartTangent    '获取的结果坐标是0.7071067,0.7071067,0
    # q9 s! [) _- Y) H. z9 T" u, ?1 A
  19.     X = SP.EndTangent      '同上,其实就是2^0.5/2,2^0.5/2,0
    * F* N7 F4 Q& V3 |
  20.     Dim p1(2) As Double, p2(2) As Double
    5 r! n% H* g+ m3 R4 m/ A5 w, B4 o1 C
  21.     p1(0) = 2: p1(1) = 7
    / E/ H+ \' g; x* n1 l
  22.     p2(0) = 6: p2(1) = 95 {, h# m7 H8 G# O! I
  23.     SP.StartTangent = p1    '修改属性值,从新指定起点切向角: ]) c$ ~; {% A6 g
  24.     Update
    3 r0 G# M2 v1 m+ x5 b
  25.     SP.EndTangent = p2      '修改属性值,从新指定终点切向角
    ( ?# z$ M$ Y* L( `& ]
  26.     Update- n  p. x) c8 V. a% i
  27.     X = SP.StartTangent    '新的切向点坐标2,7,0/ o/ r1 ?) C; y, r8 z8 B
  28.     X = SP.EndTangent      '新的切向点坐标6,9,0
    9 E$ c1 N: p7 v6 s$ v/ w
  29. End Sub
    ( K) }; e, X2 e) o$ f
复制代码
: p. a- p7 K% n4 j/ V3 c3 b
 楼主| 发表于 2019-3-29 21:12:53 | 显示全部楼层
C、画函数曲线
可以用样条曲线来画函数图像。
% v! {! o  {$ y3 J  k
  1. Sub 三角函数()
    6 A! Q6 c4 R1 v( D
  2.     Dim P(299) As Double, SP As AcadSpline
    0 R7 B. w' f5 r) M6 K- h" o" p
  3.     Dim startTan(0 To 2) As Double, C4 {  L- r2 z. J) I5 n9 z
  4.     Dim endTan(0 To 2) As Double
    ! J  D7 \1 e$ Z, C6 l- m% n$ |& ~( k
  5.     Dim M%- n! {: w3 p; c. x: K* o8 r
  6.     Const π As Double = 3.141592653589799 F8 o3 @" e% R  @( n6 e
  7.     For M = 1 To 100
    7 U. H4 y& m+ N3 c2 r2 C+ b: g! d9 f
  8.         P(3 * M - 3) = M * 0.1
    - B  }8 O& Y' }% v
  9.         P(3 * M - 2) = Sin(M * π / 10)
    / E1 @0 s0 }" D
  10.         P(3 * M - 1) = 0
    ' o' x4 {7 O1 y% n' u4 A
  11.     Next# e' R4 y% r2 p7 p3 ^
  12.     startTan(0) = 0: startTan(1) = 0: startTan(2) = 0      ‘都是0表示默认CAD切向
    0 g! y* ^( e# f0 G$ Y4 _1 m; q2 y
  13.     endTan(0) = 0: endTan(1) = 0: endTan(2) = 0        ‘同上
    % k! q$ c0 B+ |3 x
  14.     Set SP = ThisDrawing.ModelSpace.AddSpline(P, startTan, endTan)
    * s5 S5 |7 e+ {: d7 D
  15. End Sub
    0 E; \* w# Y# k* ^& |# u# B) j4 S
复制代码
  1. Sub 二次函数()
    6 Q$ I( _3 E* A4 r5 ^# `9 P
  2.     Rem Y=0.2*X^2+0.3*X-84 x& k( N7 i2 I- n% j
  3.     Dim ps(902) As Double, SP As AcadSpline4 U6 Q9 F$ }( p! q4 m! B
  4.     Dim startTan(0 To 2) As Double
      P6 o9 |* r" S! N
  5.     Dim endTan(0 To 2) As Double
    , v  U, a9 a2 G2 a
  6.     Dim x#, y#
    5 r) U# H7 p! U9 p, @5 b7 T
  7.     For x = -150 To 150& Z$ W. N$ w: A0 t6 }
  8.         y = 0.2 * x ^ 2 + 0.3 * x - 8
    ' k% l5 j& u5 F! ^
  9.         ps(3 * (x + 151) - 3) = 0.1 * x
      P  T+ y0 I3 N4 h$ C
  10.         ps(3 * (x + 151) - 2) = 0.01 * y
    ; x0 _+ @- y3 o4 i1 b; G" F! |+ J% N
  11.         ps(3 * (x + 151) - 1) = 0          'Z坐标值不写也可以,默认为0* o; }% U- Q5 D: ^4 c* ~0 x  U5 c
  12.     Next  N8 J" `0 {) G  p( ~& p6 {0 ?
  13.     startTan(0) = 0: startTan(1) = 0: startTan(2) = 0
    3 S# X. q1 |$ T  m
  14.     endTan(0) = 0: endTan(1) = 0: endTan(2) = 0; F  e1 ~7 ~, g' X3 ], R5 E
  15.     Set SP = ThisDrawing.ModelSpace.AddSpline(ps, startTan, endTan)( f6 m; C7 E. X7 Q% V1 O
  16. End Sub( J" ]) _" _& x1 ]
复制代码
  1. Sub 二次函数02()$ ]+ S0 Q* v/ h! W. H% ^; k1 B
  2.     Rem Y=0.2*X^2+0.3*X-8
    , w7 A& [2 _& F# h
  3.     Dim ps(902) As Double, SP As AcadSpline% k; ~/ _; |. Z1 y2 h3 g
  4.     Dim startTan(0 To 2) As Double4 Q/ |- [; z" A4 T5 r
  5.     Dim endTan(0 To 2) As Double. F# g: Y) y6 O% O# j5 i0 ~+ r
  6.     Dim x#, y#
      e7 n3 `  A* y, o. P1 i5 e! i% A
  7.     For x = -150 To 150
    8 S* X- t, H" Z& A+ B& a8 E
  8.         y = 0.2 * x ^ 2 + 0.3 * x - 8: d- H8 N4 g- n, c
  9.         ps(2 * (x + 151) - 2) = 0.1 * x
    & J2 @9 F* u- `( C4 q
  10.         ps(2 * (x + 151) - 1) = 0.01 * y/ [: r" C0 H8 c/ n, }
  11.     Rem 样条曲线的点坐标默认每3个坐标为1个点,后续没有赋值的点默认为0,所以此例画出的是三维图像!) F8 A( \- p1 }4 J0 k
  12.     Next
    9 ~8 n, B0 F2 C- |7 U3 S# i
  13.     startTan(0) = 0: startTan(1) = 0: startTan(2) = 0
    7 W" W. L  P* U" b; R
  14.     endTan(0) = 0: endTan(1) = 0: endTan(2) = 0* }9 C- u+ P5 e$ u3 M5 S& |& i/ e" n
  15.     Set SP = ThisDrawing.ModelSpace.AddSpline(ps, startTan, endTan)
    2 E, X( P: i6 A. ^( K  ~
  16. End Sub
    9 ~0 T. J  c* n6 }& {% R7 W2 a& q
复制代码
  1. Sub 任意函数()         '没成功!!!!!0 t8 ]$ ]1 \( m( H( @' b' f
  2.     Dim ps(902) As Double, SP As AcadSpline
    7 q8 k! H. L& X6 I; }1 n
  3.     Dim startTan(0 To 2) As Double: v5 `' r" n  z2 T$ T: X
  4.     Dim endTan(0 To 2) As Double
    ; f; R. W' U$ b
  5.     Dim x#, y#, F! q$ r; n' i( Q9 j; z2 d
  6.     F = InputBox("请输入一个关于x的表达式:")
    $ C$ q& K( e! e: k4 Y. q
  7.     '    F = ThisDrawing.Utility.GetKeyword("请输入一个关于x的表达式:")   '该方法首先需要一个关键字列表,然后从中选择。5 q/ X$ b. `+ j3 r! Q2 F
  8.     '    F = ThisDrawing.Utility.GetString(False, "请输入一个关于x的表达式:")   '直接返回字符串,后续不可用,使用val转换只能得到0
    5 e& P  c% C) F5 E( W
  9.     '    F = ThisDrawing.Utility.GetInput()     '该方法首先需要一个关键字列表,然后从中选择。3 v0 I% y* P4 ^0 Z
  10.     For x = -150 To 150& w- z# u1 q" }' X" U! q
  11.         y = Evaluate((Replace(F, "x", x)))  '在Excel中使用Evaluate函数可以取值(不能自动识别变量,需要用replace函数替换一下)。但是CAD中不行啊!用VAL函数转换也不行。
    # L. A& g6 @* W0 k" A
  12.         ps(3 * (x + 151) - 3) = 0.1 * x+ f6 y8 y) _  d/ G7 \0 T9 d
  13.         ps(3 * (x + 151) - 2) = 0.01 * y
    0 j1 R* z: _' s7 \4 h
  14.         ps(3 * (x + 151) - 1) = 0
    ) l9 o5 N$ _; y, K0 G
  15.     Next3 J% K- M7 R1 r; l. W' D9 Z
  16.     startTan(0) = 0: startTan(1) = 0: startTan(2) = 0
    , G# c4 S( g( ~  a: a' d
  17.     endTan(0) = 0: endTan(1) = 0: endTan(2) = 0
      N" p5 n% s7 b' A) f
  18.     Set SP = ThisDrawing.ModelSpace.AddSpline(ps, startTan, endTan)9 Z5 s. n, U: s& t- }- Y( f
  19. End Sub
    9 v* m9 k9 ^1 T+ v
复制代码

$ y' [7 T( {& f0 b9 s& i
2.15、样条曲线对象(SpLine).zip (10.36 KB, 下载次数: 1)
 楼主| 发表于 2019-3-29 21:14:59 | 显示全部楼层
16、椭圆对象(Ellipse)% ?4 E1 n0 H7 x* E

  H1 Y" f+ D5 b4 V. r( NA、添加椭圆方法(AddEllipse)
RetVal = object.AddEllipse(Center,MajorAxis, RadiusRatio)   
以上方法是给定中心点、长轴的一个端点短轴与长轴半径比WCSXY平面上创建椭圆。
CenterVariant[变体] (三元素双精度数组); 仅用于输入指定椭圆中心点的三维WCS坐标。
MajorAxisVariant[变体] (双精度); 用于输入长轴端点的三维WCS点坐标(相对中心点的相对坐标)
RadiusRatioDouble[双精度]; 仅用于输入定义椭圆短轴与长轴比例的正值(0<RadiusRatio≤1)。半径比为1.0时定义的是圆。比值越小越扁。
RetVal结果就是新创建的椭圆对象。
说明
椭圆可以是闭合的或开放的(即椭圆弧),它创建于当前WCSXY面上。该对象表示一个真正的椭圆,而不是多段线拟合的椭圆。要画椭圆弧必须先画椭圆,然后修改椭圆的起始角和终止角属性值来画椭圆弧
6 K$ k: Y* Z! p8 ~) N  i
  1. Sub AddEllipse方法01()* ~! D/ q5 ~$ ^3 C$ j
  2.     ' 该示例在模型空间中创建椭圆。9 a# D3 G( a2 H* x
  3.     Dim ellObj As AcadEllipse
    1 K% c- B: l( @9 K4 \3 f% c
  4.     Dim majAxis(0 To 2) As Double
    - G. k% P( K+ x$ m9 C
  5.     Dim center(0 To 2) As Double
    ! J+ k' X) T7 X0 K8 t# q4 G
  6.     Dim radRatio As Double  w5 G" g$ p) X+ \3 t2 ?
  7.     Rem 其中第二参数majAxis表示的点坐标是相对第一参数的相对坐标
    ! l8 u) P9 C/ H. \/ C1 l5 W
  8.     Rem 在绘制的图中第二参数表示的点在长轴的一个端点上。需注意!!
    : ?) i9 z; }9 E
  9.     center(0) = 5#: center(1) = 5#: center(2) = 0#- Q- f+ r5 ?7 {, r$ v  c# z
  10.     majAxis(0) = 10: majAxis(1) = 20#: majAxis(2) = 0#  '只输入一个值,默认另两个坐标为02 z8 g: r6 U" t1 V- D) Y' G
  11.     radRatio = 0.3
    / i6 f3 R0 p' s! g
  12.     Set ellObj = ThisDrawing.ModelSpace.AddEllipse(center, majAxis, radRatio)
    , B: K7 U& z& ~7 A# Q) F+ ^* q2 H
  13.     Update, X+ k- B2 I4 d) @2 M$ R/ c" w1 f
  14.     Call ThisDrawing.ModelSpace.AddLine(center, majAxis)" o& x$ G5 D1 v8 s: w
  15.     '直线的终点坐标是绝对坐标,所以不在椭圆的端点上。
    ( M8 {  |) s9 {1 O8 T, v. f! {2 I$ c! c
  16.     Update
    . ?( W; j1 k! A5 M& m* C6 I  {) U
  17. End Sub
      B2 b1 Z. n0 d3 T7 w
复制代码
可以使用椭圆方法画一个灯笼:)

+ l1 E) O4 S, t6 i3 R% P# B
  1. Sub AddEllipse方法画灯笼()4 Z4 W3 |) [& S# l
  2.     Dim ellObj As AcadEllipse
    3 Q6 h/ C7 ]/ Y& ^' o% J
  3.     Dim majAxis(0 To 2) As Double5 l* \& m, Z% j: x$ T6 W4 T; ?" h
  4.     Dim center(0 To 2) As Double
    . I% [2 G# H5 `; p9 e9 k4 P: a2 C
  5.     Dim radRatio As Double, m%: I6 h- T: I6 e7 X6 n# \7 x6 t
  6.     For m = 1 To 20
    ! L+ \2 @. B  O  m) m
  7.         center(0) = 5: center(1) = 5: center(2) = 06 D5 d- N" G8 a" {+ L: d. e) C' ?
  8.         majAxis(0) = 10: majAxis(1) = 20: majAxis(2) = 0: Z/ \. A; ^/ W3 f# o
  9.         radRatio = (m - 1) * 0.05 + 0.05 '取值范围大于0,小于等于11 w- ]9 H: _! |" Z) e  B
  10.         Set ellObj = ThisDrawing.ModelSpace.AddEllipse(center, majAxis, radRatio)
    8 D& B# F5 X* }# d1 [
  11.         Update
    % _( C( g% s' g7 _3 I. a
  12.         ellObj.Copy9 z- R' Q) c7 m* q" k/ w6 o8 n  Q
  13.         ellObj.Rotate center, 3.1415926 / 2   '绘制的椭圆先复制后绕中心旋转90°
    - h2 a9 m( {( w  n; I" `8 y9 ]
  14.         Update) T; P# J* d8 x/ F8 S4 o& G
  15.     Next, I' ]$ }5 q, v% D
  16.     Dim p1(2) As Double, p2(2) As Double, L As AcadLine
    2 I# E6 m+ @9 ]" h; R/ {' K2 ^
  17.     p1(0) = majAxis(0) + center(0): p1(1) = majAxis(1) + center(1)% M& t$ l( R) r9 {% l+ s  a
  18.     p2(0) = -majAxis(0) + center(0): p2(1) = -majAxis(1) + center(1)+ F1 w6 }, P( [1 I5 N5 O: G- ^
  19.     Set L = ThisDrawing.ModelSpace.AddLine(p1, p2)% V7 w" T: ^# y7 u% ^9 U
  20.     Update/ d$ W/ ?% v: `; q
  21.     L.Copy" A% n+ I6 r! ?* a, O$ o8 N& N+ I
  22.     L.Rotate center, 3.1415926 / 2 '直线先复制,后绕中心旋转90°
    ' n! n% D4 q, T0 L3 a1 p1 Y' b
  23.     Update( t! z; e+ J, H) P0 u
  24. End Sub
    % p0 F5 |0 l- h8 F+ a: L
复制代码
& m) T+ p" Y) o. u7 x4 E. K

5 o& _* g, @+ C8 Y) A; ~- ^
 楼主| 发表于 2019-3-29 21:17:27 | 显示全部楼层
B、椭圆对象(Ellipse)的常用方法及属性
椭圆对象的常用方法与其他对象一样,并没有特别的方法,常用的方法如:Copy、Delete、IntersectWith、Mirror、Move、Offset、Rotate、Update……具体语法不再赘述,参考示例如下:
需注意:椭圆对象偏移后的结果对象(数组)的图元不再是椭圆,而是样条曲线。
  1. Sub 椭圆常用方法()! G/ l" Z1 C# N+ M; x  n
  2.     Dim ell As AcadEllipse4 _& g' W& ~: _# {# X2 F* l' \
  3.     With ThisDrawing; `1 _9 F- i: i; Y* P5 h
  4.         Set ell = .ModelSpace.AddEllipse(.Utility.GetPoint(, "请选择椭圆中心点"), .Utility.GetPoint(, "请选择椭圆的长轴端点"), .Utility.GetReal("请输入椭圆半径比(0,1]"))
    ; ~+ t0 O% ?0 S% f  p
  5.     End With8 t9 k# B% E! U. N
  6.     Update
    , w9 q/ X1 U# c# ^; ^1 a* M
  7.     Rem 上面的写法在选择第二个参数时不会产生一条弹性线跟随鼠标动) C7 r$ A- F* P$ w' B" C, K  G+ l
  8.     Dim P0 As Variant
    8 p, j5 @4 [6 `8 f( w! E, [! O
  9.     With ThisDrawing2 Y( g$ g) Q* K/ K8 i
  10.         P0 = .Utility.GetPoint(, "请输入椭圆中心点")
    + Y$ ]1 q/ B5 G, P
  11.         Set ell = .ModelSpace.AddEllipse(P0, .Utility.GetPoint(P0, "请选择椭圆的长轴端点"), .Utility.GetReal("请输入椭圆半径比(0,1]"))4 d! N' \0 A5 i: o
  12.         Update
    ( f) ~" u! g! Q
  13.         Rem 上面的写法则可以在选择第二个参数时从第一个点到鼠标之间有一条弹性线跟随鼠标动。2 D" V7 C7 q6 ?# G
  14.         Rem 不管是点选还是输入的坐标,均是将第二个参数坐标值按照第一个参数中心点的相对坐标来绘制椭圆。- E$ y9 n0 k0 E. F; Q/ h
  15.         Dim ells As Variant& J) F6 Z2 y8 {: i9 x
  16.         ell.Copy
    - \& P* S" p/ ?0 H1 M7 I
  17.         Update* g2 }2 s9 [, X! q
  18.         ell.Move .Utility.GetPoint(, "请选择移动的第一个点"), .Utility.GetPoint(, "请选择移动的第二个点")# W; W( r! \6 v; `) ^, c) {3 }9 L
  19.         Update
    2 z# A3 l" H' K3 n! j# l
  20.         ells = ell.Offset(.Utility.GetReal("请输入偏移距离,正外移,负内移"))    '偏移结果是新对象数组,而且图元不再是AcadEllise,而是样条曲线
    % j, S+ p5 ?8 U0 w
  21.         Update2 _, S% a& p0 U# Z
  22.         ells(0).Rotate .Utility.GetPoint(, "请选择旋转的中心点"), .Utility.AngleFromXAxis(.Utility.GetPoint(, "请选择旋转角的第一个点"), .Utility.GetPoint(, "请选择旋转角的第二个点"))
    ) m) O+ F' h$ x6 G" m4 L
  23.         Rem 上面旋转时先提示第一个点,再提示第二个点,最后提示中心点。。。??这是为啥?
    $ L( A2 h6 t9 g1 |& ]/ t
  24.         Update! ~4 `0 O3 A. ~- t! z" c" g4 r
  25.         ells(0).Mirror .Utility.GetPoint(, "请选择镜像轴的第一个点"), .Utility.GetPoint(, "请选择镜像轴的第二个点"): f" v8 S5 M' ^' |1 _
  26.         Update
    3 ~; z3 g; l( b
  27.         Dim PS As Variant
    ! H* ~" |3 Q6 z) {# E1 k! c
  28.         PS = ell.IntersectWith(ells(0), acExtendBoth)  '若相交,获取交点坐标数组,不能直接使用msgbox显示。
    ! T, W  a6 K, [" t! A3 q
  29.         Dim obj As Object, h! W, |; P. ^! N. [* J& [$ b& }" z  P% v
  30.         For Each obj In .ModelSpace
    . _2 m3 [* x, J# X3 b
  31.             If TypeOf obj Is AcadEllipse Then, \- P, t8 h2 K" }0 D2 Z& j3 l- p) D
  32.                 obj.Delete
    , Y: e3 i0 e+ [( n' A0 M
  33.                 Update
    2 a( f3 F: M' [
  34.             End If* [; F5 b( p  Y3 U1 m+ o
  35.         Next
    * f6 M" v. z; i
  36.     End With
    5 V6 h3 o) I* j7 C, H! q
  37. End Sub
    - ~/ Q! ~$ ]* v! M1 r
复制代码
2 u: Z2 c: q' ?+ @
椭圆对象的常用属性:其他简单的属性参考示例理解。
  1. Sub 椭圆常用属性()7 y) B% r! V6 a  l. Z6 u
  2.     Dim ell As AcadEllipse, x As Variant
      a( N! v& ^; `8 T: P2 w( v
  3.     Dim p1(2) As Double, p2(2) As Double, S As Double
    + w" m. V' z" k- _) R& s& v3 d
  4.     p1(0) = 5: p1(1) = 5
    * N" u# ]0 [; _) N' w: K
  5.     p2(0) = 15: p2(1) = 15) z3 K3 L4 f3 D
  6.     S = 0.37
    4 N  X/ w3 J$ \& D
  7.     Set ell = ThisDrawing.ModelSpace.AddEllipse(p1, p2, S)+ g% b' y; P3 _" a
  8.     Update
    % P5 V3 c1 V' w3 z
  9.     x = ell.Area            '获取椭圆的面积523.0752,只读属性
    ! Z7 t$ t5 N; r% v# `) [. r1 e
  10.     x = ell.center          '获取椭圆的中心(5,5,0)
    ; u6 I$ [& x6 t! j% J
  11.     ell.center = ThisDrawing.Utility.GetPoint()    '也可以修改中心属性,相当于移动* i0 M  o" f, c+ i
  12.     x = ell.EndAngle        '获取椭圆的终止角,完整椭圆终止角是2π弧度,可修改- Z: E9 {- I  O0 L. b& ~
  13.     x = ell.StartAngle      '获取椭圆的起始角,完整椭圆的起始角是0弧度,可修改) Z, U: \2 f, ]6 Y
  14.     x = ell.StartParameter  '获取椭圆的起始参数,完整椭圆的起始角是0弧度,可修改% ^. p0 o0 \" v* z+ G' @
  15.     x = ell.EndParameter    '获取椭圆的终止参数,完整椭圆终止角是2π弧度,可修改
    3 n7 A5 e  J$ m
  16.     x = ell.EndPoint        '椭圆终点坐标,(20,20,0),也就是第二参数指定的长轴端点的绝对坐标,只读属性9 U$ g* W# j8 z3 C* N3 ~- \2 K0 {
  17.     x = ell.StartPoint      '椭圆起点坐标,(20,20,0),也就是第二参数指定的长轴端点的绝对坐标,只读属性. h( b) x, u+ ~0 W7 {
  18.     x = ell.RadiusRatio     '获取椭圆的短轴和长轴半径比,可修改' Q; K7 V0 s# t) }$ l! U- {: `' d
  19.     x = ell.MajorAxis       '获取椭圆长轴端点坐标(15,15,0),是相对中心点的相对坐标8 _/ F" X+ A2 b- c. a5 \
  20.     x = ell.MajorRadius     '获取椭圆长轴半径
    % C# M, ?  ~  H! [
  21.     x = ell.MinorAxis       '获取椭圆短轴端点坐标(-5.55,5.55,0),逆时针旋转先经过的短轴端点坐标(相对中心的相对坐标)
    + t/ @5 U( B% s
  22.     x = ell.MinorRadius     '获取椭圆短轴半径8 H' w' I0 @2 c% [3 o
  23. End Sub
    0 g$ g- d. n4 y) k( z0 q
复制代码

& b9 Z! ?3 [9 s" x) V1 c6 \# l# W, \" P4 S

6 x3 J) W& |" Y/ x
 楼主| 发表于 2019-3-29 21:19:53 | 显示全部楼层
C、创建椭圆弧对象
下面介绍一下通过修改椭圆的属性来创建椭圆弧:
1Ellipse.EndParameter属性:指定椭圆的终点参数角,[double]可读写,范围在[0,2π]
Ellipse.StartParameter属性:指定椭圆的起点参数角,[double]可读写,范围在[0,2π]
椭圆的起、终点坐标起、终点参数角关系按如下方程计算(按照椭圆所在面为XY平面,Z坐标默认0)。起、终点P的坐标为:P(X) =A * cos(θ) ,P(Y)= B * sin(θ)
以上坐标公式是在对象坐标系OCS中成立。在绝对坐标中仅中心点在(0,0,0),指定长轴端点在水平向右方向时成立!
起、终点参数角弧度的确认:以椭圆中心点为坐标原点,指定的椭圆长轴端点为X轴正方向,逆时针旋转为正角。但是实际得到的起、终点对应角度不一定是指定的参数角。
其中AB是椭圆的半长轴与半短轴。θ是指定的起、终点参数角弧度值。
2Ellipse. StartAngle属性:指定椭圆的起点角弧度[double]可读写,范围在[0,2π]
Ellipse. EndAngle属性:指定椭圆的终点角弧度[double]可读写,范围在[0,2π]
起、终点角弧度的确认:以椭圆中心点为坐标原点,指定的椭圆长轴端点为X轴正方向,逆时针旋转为正角。实际得到的起、终点对应的角度就是指定的起、终点角度。
3、角弧度θ和参数角弧度α的关系:tan(θ)=b*tan(α)   (b是半短轴与半长轴半径比)
可以用角弧度或参数角弧度来画一个椭圆。
. C! l& I: z( K4 r5 a. `+ N# _
  1. Sub 椭圆起止参数和角度属性()  i( p3 O6 o' D6 c  ]9 e
  2.     '此示例创建椭圆,并输入开始和结束参数以创建椭圆弧。. i7 ~* d. r9 @9 B/ S# \
  3.     Dim ellObj As AcadEllipse, ellobje As AcadEllipse* u  a9 X) P# p8 n" ~* k8 c
  4.     Dim majAxis(0 To 2) As Double8 O. D8 P$ q/ U1 k, o  |
  5.     Dim center(0 To 2) As Double! R6 `" o3 `) Y& I
  6.     Dim radRatio As Double9 w3 ^# N  m( ~! j8 L
  7.     Dim p1(2) As Double, p2(2) As Double/ m7 o0 c, h( |1 Q( g) I
  8.     center(0) = 5#: center(1) = 5#: center(2) = 0#
    # A7 [. W. W$ F8 j( V
  9.     majAxis(0) = -10: majAxis(1) = -20#: majAxis(2) = 0#: A. u* R9 Z  m
  10.     radRatio = 0.3% e1 Z2 E- H0 y
  11.     Set ellObj = ThisDrawing.ModelSpace.AddEllipse(center, majAxis, radRatio)& I, @* }# H  s, R' S6 M( |! |( T
  12.     Set ellobje = ellObj.Copy' j/ ]: Z3 e) U- t& @- x% Y
  13.     p1(0) = 5: p1(1) = 5; ?9 t: o2 _+ W) w+ h
  14.     p2(0) = 20: p2(1) = 5
    + P6 u+ m2 w+ U" O5 z( h
  15.     ellobje.Move p1, p28 u& z$ O& v2 D8 Z3 {
  16.     Update
    % Y. R) U* c: l1 q5 ~, u5 t
  17.     ' 输入开始参数1.57,结束参数6.28,可创建椭圆弧0 R5 [6 H2 o; Q+ b9 Z, K5 K
  18.     '角度的基准线是按照创建椭圆的中心点为原点,第二参数指定的端点为X轴正方向,逆时针旋转为正角。
    & i8 X( Q  S, d& M& P$ c& R
  19.     ellObj.StartParameter = 3.1415926 / 2       '起始参数π/2=90°图上显示的角度也是90°。* N6 a7 q4 b" M6 x8 M3 g& z& ^, y
  20.     Update
    " ?3 D! q5 b& T9 x! \0 @$ p) W
  21.     ellObj.EndParameter = 5 * 3.1415926 / 3     '终止参数为5π/3=300°,但是图上显示的是332.542919°
    ; q& e% D. B6 j% h' T; e4 u
  22.     Update
    ; `( n' d- s. }
  23.     Rem 下面通过修改起止角弧度来创建椭圆弧
    ' J* p; h' _& P! `' g* O
  24.     '角度的基准线是按照创建椭圆的中心点为原点,第二参数指定的端点为X轴正方向,逆时针旋转为正角。
    0 E6 R1 _* ~) N  l3 T
  25.     ellobje.StartAngle = 3.1415926 / 2          '起始角度为π/2=90°
    + D, k7 M3 G$ E0 Z
  26.     Update
    1 f& _6 c5 ]( j# {) n
  27.     ellobje.EndAngle = 5 * 3.1415926 / 3        '终止参数为5π/3=300°
    : M/ k9 [- C% w% x: H+ `2 j
  28.     Update2 q, y" ?4 A3 [6 p# a7 r
  29.     Dim x As Variant1 x, F# X+ l  C4 G# @! a, F
  30.     x = ellobje.StartPoint   '从指定的长轴端点开始逆时针旋转先经过的点为起点
    : g8 A0 q+ a, |2 }  d
  31.     x = ellobje.EndPoint     '从指定的长轴端点开始逆时针旋转后经过的点为终点4 O( J" o# Y: Z
  32. End Sub/ R" A9 f  o& E0 u
复制代码
6 {# s# t4 I2 i2 X
& H7 ]1 A: E' P4 k3 s
  1. Sub 角度与参数角属性01()* J& T9 Y' D* Y1 f. `/ O$ h) N# H9 ^
  2.     Dim ell As AcadEllipse, p0(2) As Double, p1(2) As Double, b As Double
    7 w5 R0 @! u6 O: G" }
  3.     p0(0) = 0: p0(1) = 0      '便于观察,将中心点设置在坐标原点处8 i5 J7 q# L  ~& w8 y
  4.     p1(0) = 20: p1(1) = 0     '为了方便操作观察,半长轴为20,沿中心点水平向右. q& j1 a) S2 Q# R
  5.     b = 0.5                   '半短轴为10. ]0 Q/ x; L/ Y+ Q5 v- J
  6.     Set ell = ThisDrawing.ModelSpace.AddEllipse(p0, p1, b)
    " @2 S0 L' @5 a! ?' G  z
  7.     Update  j3 e' V0 k) V3 w& G
  8.     Rem 接下来设置起终点的参数角弧度属性
    " r7 {$ H6 Y* q* c# J
  9.     Const π As Double = 3.14159265358979" q" ~+ e- |) b0 U9 K
  10.         ell.StartParameter = π / 4
    % f& b; R7 W, f% ]) w: B: `
  11.     '设置起点参数角为45°,根据公式计算的起点坐标应为(20*cos(45°)=10*2^0.5,10*sin(45°)=5*2^0.5)
    1 B# i9 P; y- Y  l! c
  12.     '结果起点坐标根据公式计算正确!但是起点所在角度并不是45°,而是26.565051°: s1 G( x/ b- {- f: k+ a6 G% x" u
  13.     Update4 D/ u( r* }  d
  14.         ell.EndParameter = 5 * π / 36 b: g# z% P. ]1 P! |
  15.     '设置终点参数角为300°,根据公式计算的终点坐标应为(20*cos(300°),10*sin(300°))
    & p8 Z) T& Y1 o/ R% E- F( g5 y4 u9 I
  16.     '结果终点坐标根据公式计算正确!但是终点所在角度并不是-60°,而是-40.893395°/ |& `3 T2 H% D) D" D' h; |+ e
  17.     Update" k6 V4 n& X% l& k. s* d: g
  18.     Rem 接下来设置起终点的角弧度属性$ _0 A6 ~, D  W  G  T1 Q9 w9 J* P
  19.     '    ell.StartAngle = π / 4( K9 G4 \( F* @
  20.     '    ell.EndAngle = 5 * π / 3
    & x2 N+ m* r; f) X+ ~0 h3 r7 |- H
  21.     Update   '发现起终点角度属性就是根据圆心及指定的长轴端点为X轴正方向逆时针旋转对应角度。
    - a+ \* q2 y: N  ]/ c+ G
  22.     ell.StartParameter = 1.10714871779409   '该弧度角的正切值为2=tan(π/4)/0.5; z. p# F5 Z( o
  23.     ell.EndParameter = -1.28976142529208    '该弧度角的正切值为-3.46410161513775=tan(5*π/3)/0.5+ `3 \+ g* `/ C% J& i
  24.     Update   '通过上例证明角度与参数角满足关系tan(角度)=椭圆半径比*tan(参数角)
    4 q- ]3 D3 l) w
  25. End Sub: {( Z6 n9 K/ m8 A# ^
复制代码

+ h8 ~9 r2 o+ x% q; D

, p+ Q# P, O3 K5 ^7 k/ e; _9 _5 K 2.16、椭圆对象命令(Ellipse).zip (11.71 KB, 下载次数: 2)
 楼主| 发表于 2019-3-29 21:22:02 | 显示全部楼层
本帖最后由 kuangben8 于 2019-7-1 22:08 编辑
( b0 t8 M' `0 ?% H+ H4 y6 r" M
0 m2 z3 ^( c, z/ ~! I/ O三、实现ExcelAutoCAD之间数据交互
: O/ ~# U+ G9 t% _5 ^1、通过Excel编程调用指定AutoCAD文档自动画图) P# [; ]0 I, b( g5 P" j- ?2 O' @

0 D: u7 W7 B2 @6 \需注意:
通过Excel调用AutoCAD程序文档之前,需要在Excel的VBE窗口中:工具---→引用,在弹出的窗口中必须勾选本机对应的AutoCAD程序库才可以正常调用CAD程序及文档.如下图所示:
1561906577(1).jpg

& ?5 _/ w5 o& S6 c9 s- z
基本调用方法如下:
  1. Sub 调用CAD方法02(). H" |1 e' k/ ?! m0 @
  2.     Dim CAD As AcadApplication, DOC As AcadDocument
    1 w! u' W4 i7 m4 U. y
  3.     Set CAD = CreateObject("AutoCAD.Application") '运行一个新的CAD进程4 C8 i+ I9 I# E4 h  ]
  4.     CAD.Visible = True '让新的CAD进程可见,这可以在CAD图形界面手工操作。否则只能用EXCEL在后台操作
    # |$ Y. C9 e7 r+ o% M% a( `
  5.     '也可以用下面这行
    1 _# s4 ?2 Q; N1 N, f
  6. '    Set CAD = GetObject(, "AutoCAD.Application") '获得一个已经运行的CAD进程,在已经有CAD文档打开时使用!
    ( w5 {5 q0 A9 A3 U9 H
  7.    
    : ~% I9 q/ g4 c9 C
  8.     '指定要使用的文档的方法,可选用下面五行之一
    8 v$ B1 W7 m2 d& M6 L, b
  9. '    Set DOC = CAD.ActiveDocument '指定使用活动(正在前台的)CAD文档5 W6 c. G$ k. ?
  10.     Set DOC = CAD.Documents.Open(ThisWorkbook.Path & "\CAD编程文件.dwg") '打开一个指定路径指定名称的CAD文档,打开后只有一个指定CAD文档窗口
    3 j7 R9 `* r* M  C1 u, k2 d
  11. '    Set DOC = CAD.Documents.Add() '新建一个CAD文档
    5 R* ~& {5 y$ x' \" \# _+ S
  12. '    Set DOC = CAD.Documents.Item(0) '指定当前已经打开的文档中的某一个——用索引号指定。
    " G& W# x/ l/ \7 [$ C
  13.     Rem 索引号从0开始,最大索引号比已经打开的文档数(Documents对象的Count属性)小1。
    : L3 V9 M8 M$ k" W: s8 ?
  14. '    Set DOC = CAD.Documents.Item("CAD编程文件.dwg") '指定当前已经打开的文档中的某一个——用文件名指定9 T) e$ q3 r  l% @6 v- g
  15.    
    ! \$ ~' w8 E* M' d7 M, S  k% n
  16.     DOC.Activate '使指定的文档成为活动文档) J: [6 X  m$ h
  17.     DOC.SaveAs ThisWorkbook.Path & "CAD编程文件.dwg" '保存CAD文档到指定路径下的指定文档。. i& n# M( E5 v
  18.     CAD.Quit '如果运行一个新的CAD进程时,仅仅用于后台操作或完成辅助计算等,用过之后别忘了关闭它。否则每使用一次本程序就运行一个新CAD进程,次数多了电脑内存会吃不消的.* {8 t2 r  ?% |5 ^  c2 `
  19. '    CAD.Close False   '没有CAD.Close方法!( l( V# m1 x! l. U# s* S6 ^6 ]) u
  20. 'CAD.Documents.CLOSE FALSE    '关闭文档可行。. Q9 m5 v3 X. _0 Y
  21. End Sub1 h5 D- q0 S' V! V
复制代码
也可参考如下代码:
  1. Sub 调用CAD程序()! v1 w; \: C) q2 {" [
  2.     Rem 首先一定要在工具---引用---中勾选对应的CAD版本的引用库 AutoCAD 2014 Type Library1 ?7 m4 F3 A8 Z4 M$ P- A" v7 Q4 ?
  3.     Dim CAD As AcadApplication, DOC As AcadDocument" u8 K; N; A$ w1 R$ w3 h
  4.     On Error Resume Next      '忽略错误继续运行. ~1 z5 i% l+ X) d
  5.     Set CAD = GetObject(, "AutoCAD.Application")   '若已经打开CAD程序时使用1 c/ e0 w' c( K8 ~
  6.     If CAD Is Nothing Then
    * B; X2 ?; t4 i0 {
  7.         Err.Clear   '清除错误& X2 w' R9 v# Z, U6 Z
  8.         Set CAD = CreateObject("AutoCAD.Application")  '若没有打开CAD程序时使用. t. A6 n9 \7 \! y# j( E7 W9 s) ]
  9.     End If* x6 u+ G1 F9 t% I4 k) k
  10.     'CAD.Visible = True  '让CAD界面显示出来
    # A" J! o2 K% s) [1 Y' P5 c6 _9 p
  11.     Set DOC = CAD.Documents("设计绘图模板.dwg")    '不要.Item也可以。直接赋值如没有则出错!& h) N( I* y3 z" c/ t, i, ]
  12.     If DOC Is Nothing Then
    8 K7 \( u. C7 e! w/ w0 h+ G
  13.         Err.Clear
    6 W+ ?( [: u% q0 J& O& g
  14.         Set DOC = CAD.Documents.Open(ThisWorkbook.Path & "\设计绘图模板.dwg")
    % c& m- |( E+ x9 T
  15.     End If
    8 a8 w4 T5 K- o# u  c0 @
  16.     On Error GoTo 0      '恢复错误提示
    0 d% {5 Y& e7 P0 P7 D) J. t* ?
  17.     CAD.Visible = True   '此时显示界面不会出现空白CAD文档!0 i* F& O5 j% Z
  18.     DOC.Activate         '激活指定文档
    0 J0 }' R4 D) B
  19.     With DOC             '相当于CAD的VBE里的with Thisdrawing& J( G  q3 G9 x, C/ j' M
  20.         Rem 接下来就相当于在CAD的VBE中编写代码一样了!0 K5 I8 t- {% [6 z& q
  21.         Rem 方法一:以发送命令的方式画图, a$ n' }* _1 b# @
  22.         Dim obj As Object
    8 D7 F% W9 V" p, q$ C1 o3 k. {
  23.         For Each obj In .ModelSpace
    9 C4 o! r' |. o5 C# I
  24.             obj.Delete     '删除对象不会及时显示出来; P3 Z; F9 z$ f& O2 b/ I
  25.             .Application.Update. m4 P, \$ C( F6 j! m
  26.             '刷新CAD界面,直接Update单步执行没问题,但是直接运行,此步提示远程服务器不存在!,使用.Application.Update却没有问题!- K$ S: a0 L4 }+ B
  27.         Next
    $ z% p$ `/ s- C- C( {# E; K6 l
  28.         Rem 发送命令的形式绘图可以及时的显示出来9 c0 z) A1 }) ]: c& w
  29.         .SendCommand Sheet1.Cells(2, 1).Value
    - S* X) \4 Y- [5 m6 c. C: b( M
  30.         .SendCommand Sheet1.Cells(3, 1).Value
    8 e7 r  w( F' E& _: \0 ?4 t
  31.         .SendCommand Sheet1.Cells(4, 1).Value
    $ s$ I/ n0 T7 z  X6 S- ?: m
  32.         6 L4 ^+ h* A/ i# N* L
  33.         Rem 方法二:直接编写代码画图; K3 j! \. r6 g5 a. N3 J
  34.         Dim L As AcadLine, Cir As AcadCircle  z) N  X; K: D( @- g7 n: a
  35.         Dim p01(2) As Double, p02(2) As Double
    & C0 T7 _! Q3 l7 O1 O
  36.         Dim cnt(2) As Double, R As Double/ N7 j* m7 b/ q+ q* h9 o
  37.         With Sheet1
    ) a  l% l% y8 j1 O
  38.             p01(0) = .Cells(8, 1).Value
    0 x2 F/ u. `& c& x- }" C% L7 [
  39.             p01(1) = .Cells(9, 1).Value
    ( V* G8 Y' F! u
  40.             p01(2) = 0  'Z坐标也可以省略不写,默认是0
      q& C$ g& M( ~4 c  P
  41.             p02(0) = .Cells(10, 1).Value
    1 M2 P: [9 ~# f! p3 n2 L
  42.             p02(1) = .Cells(11, 1).Value) K9 a5 c: y* o4 Y
  43.             3 x; W. q! N* q2 S) C2 S
  44.             cnt(0) = .Cells(10, 1).Value
    7 F, t4 \; s! R1 b/ ]6 X
  45.             cnt(1) = .Cells(11, 1).Value: F- k! v+ K7 b# @2 t
  46.             cnt(2) = 0- M0 m. e$ ?" i1 R' q( o% v
  47.             R = .Cells(8, 2).Value
    , }! I. t5 D5 N) ^
  48.         End With) @! R, W5 ]& |% k( x
  49.         Set L = .ModelSpace.AddLine(p01, p02)
    9 h, g. y5 w3 u7 a) s
  50.         L.Update    '单独的Update单步执行没问题,直接运行同样错误,但是使用对象刷新也没问题!
    9 E7 g$ E( f6 D. \& `" e
  51.         Set Cir = .ModelSpace.AddCircle(cnt, R)
    5 x; y; p/ v: Q$ B  [
  52.         Cir.Update7 b8 n0 j" v6 m+ a6 H
  53.         cnt(0) = Sheet1.Cells(9, 2).Value6 v3 ^, Q( ^) I. O3 D% e% u
  54.         cnt(1) = Sheet1.Cells(10, 2).Value
    # ^2 x7 k9 e7 Y9 v
  55.         cnt(2) = 0# S2 g2 b3 c& U/ t6 w$ q% N
  56.         R = Sheet1.Cells(11, 2).Value
    & ^; `# ^- k4 Q1 `  [
  57.         Set Cir = .ModelSpace.AddCircle(cnt, R)
    ) H* N) @* \8 o
  58.         .Application.Update; c8 b2 b+ S& g( f& g" @- b  L, o
  59.         
    5 a6 B/ q. `5 n  c. v( H' f
  60.     End With- n( b- N/ w. X2 D3 K
  61.     'DOC.Save        '保存修改的CAD文档
    2 x! m7 V8 b; R
  62.     DOC.Close True  '或者直接关闭并保存修改的CAD文档2 ?3 S% z" f1 c/ a) X1 k  ?& F
  63.     CAD.Quit        '结束CAD进程) E+ J% J& e3 _. @$ W- v
  64.     Set DOC = Nothing   '释放变量
    : b9 `1 H( b7 z, k0 r
  65.     Set CAD = Nothing6 I6 d/ f$ u: @2 \- S  y
  66. End Sub
复制代码
Excel与AutoCAD 交互编程.zip (49.62 KB, 下载次数: 3)
 楼主| 发表于 2019-3-29 21:25:57 | 显示全部楼层
本帖最后由 kuangben8 于 2019-7-1 22:11 编辑 ! e7 ~4 M8 t9 }- o8 Z
" B; \3 S$ G% S1 q; X/ B
2、通过AutoCAD编程调用Excel数据自动绘图7 c- t6 i$ ]2 D: o
明白了使用Excel调用CAD,在使用CAD调用Excel则简单多了。套路都是差不多的!0 c) w& P$ j) U
具体参考如下代码即可。
( r5 t& @* N! {" a+ [3 o  H
  1. Sub 调用Excel程序()5 e: ?1 g2 g  s0 s3 r: m
  2.     Rem 首先一定要在工具---引用---中勾选对应的Excel版本的引用库 Microsoft Excel 16.0 Object Library
    & E' T; o8 b5 Y9 j' j- [# |( o
  3.     Dim ExcelApp As Excel.Application, EWB As Excel.Workbook, ESHT As Excel.Worksheet7 d$ o# J$ t5 f3 a, {5 `& r
  4.     On Error Resume Next      '忽略错误继续运行! o1 p, B: x* k" a2 E
  5.     Set ExcelApp = GetObject(, "Excel.Application")   '若已经打开Excel程序时使用
    + x5 A, x$ T8 [2 h. }. R) w
  6.     If ExcelApp Is Nothing Then
    , o5 A' ?7 d  }# }6 A% J: ^
  7.         Err.Clear   '清除错误
    - n* p6 Q- j+ ]; E& p  ~' p
  8.         Set ExcelApp = CreateObject("Excel.Application")  '若没有打开Excel程序时使用
    6 l% E& A- B# N2 W( M6 t* a2 y$ R7 h
  9.     End If
    & A' d  P0 v  ?$ n7 q
  10.     'ExcelApp.Visible = True  '让Excel界面显示出来,是一个没有工作表的空白的Excel文档,但是后续指定工作簿后也不会出现一个空白Excel文档。
      u/ l. {6 K3 o+ J/ o8 n
  11.     Set EWB = ExcelApp.Workbooks("Excel工作簿.xlsx")    '不要.Item也可以。直接赋值如没有则出错!) h* {! L8 F: E; }" @* e3 z$ `
  12.     If EWB Is Nothing Then
    ; }# A0 V" H6 I$ _! A
  13.         Err.Clear
    $ \9 q" N: U3 r6 S4 }; F4 b
  14.         Set EWB = ExcelApp.Workbooks.Open(ThisDrawing.Path & "\Excel工作簿.xlsx"): t3 H, B5 x, X7 |/ j# P$ C6 Y
  15.     End If6 B9 p5 K# M3 ?, h
  16.     On Error GoTo 0      '恢复错误提示( r5 B4 \. G. Q  h( h
  17.     Set ESHT = EWB.Worksheets("实验工作表")$ v/ f& Y2 W* O4 ?: ]. I
  18.     ExcelApp.Visible = True   '此时显示界面不会出现空白Excel文档!) H! z- A  G' g7 C. p8 ^% U
  19.     ESHT.Activate/ m9 i4 k! R7 U; }- w
  20.     With ESHT
    - H; r6 _0 b0 z
  21.         Dim arr, brr
    $ h: B7 u) Y6 y, A8 ]" B
  22.         .Range("A1:E10") = "AutoCAD写入": j) O- I; x& G2 J! A7 r* r6 ?3 _+ ?
  23.         arr = .Range("G3:G5")
    0 F* g6 z' E2 y. t) W4 D/ O  [$ }
  24.         brr = .Range("G8:H11"); \, G: q+ p& R% v
  25.     End With- X* e' J" _6 w& B! d# f/ o/ D3 Y
  26.     With ThisDrawing
    9 I6 [9 H3 `2 x1 @! A: e) C! h
  27.         Rem 方法一:发送命令形式画图5 W, q0 f. U& @/ g$ W7 E
  28.         'Dim m%% W3 P) V- p- b5 L
  29.         'For m = 1 To UBound(arr, 1)
    - z: Z) V) @5 ^1 O8 K+ H
  30.         '   .SendCommand arr(m, 1)    '第三组数据第一个空格不能使得CAD默认执行上一次绘图命令,所以第二个圆没成功!
    7 m; y+ W. G  g
  31.         'Next0 r+ U& ~. B, f" B
  32.         
    8 L3 p1 E; q) \. \, o8 T' C
  33.         Rem 方法二:直接使用代码画图
    ! T8 [, ?3 d9 B, K& _
  34.         Dim L As AcadLine, Cir As AcadCircle
    ' ^' v$ h: i, i" {, D- _6 X
  35.         Dim p01(2) As Double, p02(2) As Double, D/ w7 d. V* _; @8 e/ _, V( _. H3 O
  36.         Dim cnt(2) As Double, R As Double1 h) ^6 _) w, c- J
  37.         p01(0) = brr(1, 1): p01(1) = brr(2, 1): p01(2) = 0
    6 B* U$ Q, @) S* B. g% j* x! m
  38.         p02(0) = brr(3, 1): p02(1) = brr(4, 1): p02(2) = 0
    " [2 y* Y: K; G# {, I% l! O
  39.         cnt(0) = brr(3, 1): cnt(1) = brr(4, 1): R = brr(1, 2)
    7 p/ g5 s% I! [  k" y* u7 q) ?) X- \
  40.         With .ModelSpace" o9 m3 c9 G* ^$ f" |
  41.             Set L = .AddLine(p01, p02)
    8 Q7 Y- z9 M. H% C4 i) ?
  42.             Update, z6 H+ V6 |$ i4 F) S9 J
  43.             Set Cir = .AddCircle(cnt, R)
    - }) }- M0 T8 ]5 g3 [4 M: x- R
  44.             Update
    0 e2 _) X# R) l1 T
  45.         End With/ L+ z+ x8 C) F  o. h8 y/ r* [
  46.         cnt(0) = brr(2, 2): cnt(1) = brr(3, 2): R = brr(4, 2); z  ~" S% l$ D+ |
  47.         Set Cir = .ModelSpace.AddCircle(cnt, R)
    8 w5 f7 R: n" ~' [( s3 {
  48.         Update% Y' u7 S+ W) s9 w+ B% t
  49.     End With( p5 {. n# U; t  W
  50.     'EWB.Save
    3 G* p0 k/ L0 o' s
  51.     EWB.Close True    '关闭病保存Excel文档的修改
    % i- G- _) l& s( R, f0 {
  52.     ExcelApp.Quit    '关闭Excel进程; Z  ]/ Q3 n' M; f# \9 V( N: q
  53.     Set ExcelApp = Nothing   '释放变量' N  L$ ?& ~( V+ q; W- [
  54.     Set EWB = Nothing* p: k# R! d. X* S( m$ R
  55.     Set ESHT = Nothing
    ( r+ I1 u4 S- y1 b8 y" b/ _
  56. End Sub
    5 H- ~6 j; x0 v; ~% x4 F
复制代码
通过AutoCAD调用Excel数据绘图.zip (45.9 KB, 下载次数: 2)
发表于 2019-4-2 08:28:13 | 显示全部楼层

对楼主《AutoCAD中程序的保存与修改》的一点补充

AutoCAD 的 VBA 工程有两种保存和加载方法:
第一种是作为全局工程保存为单独的 dvb 文档,就像楼主在 3 楼阐述的那样。这种工程是全局的,我们可以在任何时候把它加载到正在运行的 AutoCAD 进程中来,也可以在编辑任何一个 dwg 文档时使用其中的宏。
第二种是作为嵌入工程,保存在 dwg 文档中,就像 EXCEL 的 VBA 工程保存在 xls 或 xlsm 文档中一样。这种工程是包含在 dwg 文档中的,在打开这个文档时自动加载,并且只能在编辑这个文档时使用其中的宏。
打开 VBA 管理器,最上面的“图形”下拉列表中列出了在当前 AutoCAD 进程中已经打开的全部 dwg 文档。选择其中的一个文档,如果这个 dwg 文档中包含嵌入的 VBA 工程,“嵌入工程”文本框中会显示嵌入工程的名称;如果这个 dwg 文档没有嵌入 VBA 工程,在“图形”下拉列表下面的“嵌入工程”文本框中会显示“(无)”。此时,在下面的“工程”表格中选择一个已经加载的全局工程(没有的话可以点击旁边的“新建”按钮创建一个),再点击“嵌入”按钮,这个全局工程将被“复制”到 dwg 文档中成为它的嵌入工程。
未标题-4.png

( X4 \5 A. G4 Y, C1 s# z
未标题-5.png + O4 ~  M+ e4 \* v9 o9 L# H
2 x$ n) |- c1 c# N, m
一个 *.dwg 文档只能嵌入一个 VBA 工程。
嵌入工程随 dwg 文档一同保存,无论你在图形界面保存文档还是在 VBA 编辑器界面保存文档,被保存的都是整个 dwg 文档,包括其中的嵌入工程。
对于一个嵌入了 VBA 工程的 dwg 文档,在 VBA 管理器上点击“提取”按钮,将删除文档中的嵌入工程——当然,在删除之前,AutoCAD 会询问你是否将其保存为一个全局工程(单独的 dvb 文档)。

点评

哦哦,明白全局工程和嵌入工程是啥意思了!感谢老师分享。  发表于 2019-4-2 10:00

评分

参与人数 1三维币 +10 收起 理由
kuangben8 + 10 鼓励积极应答和参与的回帖。

查看全部评分

发表于 2019-4-3 09:02:53 | 显示全部楼层

对楼主《很有用的Utility对象》的一点补充

AD、.GetObjectidString 方法(2010版新增)
4 c- r- y3 n5 G, m8 x8 D% S以字符串形式返回对象的ID。  O* k9 i6 h# v3 Q1 l3 J1 t
语法8 B" k, F# m3 N. n! x
RetVal = Object.GetObjectIdString(acadObject, bHex)) T# F3 e: [8 n. X- i$ U, H
object
: `! f! G, Y( p               Utility
. p3 X$ `& K% j( e               使用该方法的对象。( F) _3 N6 b7 U1 o
acadObject( M2 g2 r- P& ^+ T2 c
               Object[对象]; 仅用于输入
) e  a* e2 n3 s6 S               要返回其对象ID的AutoCAD对象。, b6 ^& v8 a1 z0 G
bHex
% Q# `! K' ~8 w               Boolean[布尔值]; 仅用于输入
* j+ J/ y4 X5 T0 W               确定对象ID是作为整数还是十六进制返回。9 y6 l; k1 ?3 c: c7 Q+ W3 L# W7 H* x  ]
               TRUE: 十六进制。
* ?" b9 x. N0 X: C0 \               FALSE: 十进制。) M# L" Z5 Q5 r2 X
RetVal
! K1 ~5 o# b. b9 d1 j               String[字符串]. H8 _1 D/ J+ c* ]. ?2 B2 j
               对象ID字符串。
# e- p# B+ o3 M. g, o6 q, D. X( S8 h. L+ Q
5 s! \7 n- s2 ]1 E. w; O6 [  ]

评分

参与人数 1三维币 +10 收起 理由
2005llnn + 10 鼓励积极应答和参与的回帖。

查看全部评分

 楼主| 发表于 2019-4-9 22:27:44 | 显示全部楼层
本帖最后由 kuangben8 于 2019-4-14 10:11 编辑 ( ]5 f, h' E: E+ H. k

! Y9 {0 W& ^( B" \" I' K, [关于创建图案填充的补充:(非常感谢woaishuijia老师的热心帮助,以下是老师的帮助文档+我的一点总结)
一、关于 AddHatch方法的参数
12002版及以前,AutoCAD 只有图案填充,那时的AddHatch 方法只有三个参数,即 PatternType(图案类型)、PatternName(图案名称)和 Associativity(关联性);到2004版,增加了渐变填充, AddHatch 方法就增加了第四个参数 HatchObjectType(填充对象类型)。
2、先说第四个参数 HatchObjectType(填充对象类型)
先说它的原因是它的值决定了第一个参数的用法。按我们通常的思维习惯,它本来应该是第一个参数,但由于是后增加的,所以排在了第四个。
这个参数为 AcHatchObjectType 枚举类型。如果使用变量,应这样声明
Dim ** As AcHatchObjectType
这个枚举共有两个值:
1acHatchObject= 0(图案填充):表示选择填充样式为图案填充!对应填充界面如下
001.jpg
' k3 G# ]8 O9 g
2acGradientObject= 1(渐变填充):表示选择填充样式为渐变填充!对应填充界面如下
002.jpg

% ~$ Z; d+ ?$ q$ W9 m' E' [: J& z4 U; @: x  s
这个参数是可选的,默认值为 0acHatchObject,图案填充)。
% r2 }  K/ X1 i8 M# U0 D: p
3、再来说第一个参数 PatternType
在2002版及以前,没有第四个参数(只有图案填充),这个 PatternType 参数是 AcPatternType 枚举类型。2004版及以后,这个参数的类型就有了两种选择,即:如果第四个参数HatchObjectType(填充对象类型)的值是 acHatchObject = 0(图案填充)或省略,则这个 PatternType 参数就必须用 AcPatternType 枚举类型如果第四个参数 HatchObjectType(填充对象类型)的值是acGradientObject = 1(渐变填充),则这个 PatternType 参数就必须用 AcGradientPatternType 枚举类型
这个PatternType 参数的值决定着第二个参数 PatternName(图案名称)的用法,后面再说。先说这个参数两种枚举的值:
1AcPatternType 枚举类型。如果使用变量,应这样声明
Dim ** As AcPatternType
这个枚举共有三个值:
acHatchPatternTypePreDefined = 0(预定义):使用CAD自带的填充样式!
acHatchPatternTypeUserDefined = 1(用户定义):此时CAD自带的填充样式不可选!
acHatchPatternTypeCustomDefined = 2(自定义):此时CAD自带的填充样式不可选!
这三个值对应着图形界面“图案填充和渐变色”对话框中“图案填充”选项卡上的“类型(Y”下拉列表(见图)。
! y; e( j" ?- D4 V. Z+ o8 _1 F 003.jpg
+ f# a4 o2 a# d( x$ r& C( t& {2 f# ]& k3 c: b
2)AcGradientPatternType 枚举类型。如果使用变量,应这样声明
Dim ** As AcGradientPatternType
这个枚举共有两个值:
acPreDefinedGradient = 0(预定义)
acUserDefinedGradient = 1(用户定义)
第一个值容易理解;第二个值E文是这样说的:Definesa pattern based on property values. 翻译:基于属性值定义模式。比较费解。经多次尝试,出错的提示总是“尚未实现”,且图形界面“图案填充和渐变色”对话框中也没有对应的选项。猜想这是为 AutoCAD 为今后的渐变填充改进预留的,就是说这个枚举目前只能用 acPreDefinedGradient = 0(预定义)值。

. |' D" k5 T8 R9 [# m
4、第二个参数 PatternName(图案名称)
1)当第一个参数 PatternType 是 AcPatternType 枚举类型且其值为 acHatchPatternTypePreDefined = 0(预定义)时,图形界面“填充图案选项板”(见图)上的“ANSI”、“ISO”和“其它预定义”选项卡上的所有图案名称都可以用。
2)当第一个参数 PatternType 是 AcPatternType 枚举类型且其值为 acHatchPatternTypeUserDefined = 1(用户定义)时,本参数只能为"_U"。这个图案没有什么实际用处。所以 AcPatternType 枚举类型的值 acHatchPatternTypeUserDefined = 1(用户定义)我认为至少在当前阶段是多余的,也许随着 AutoCAD 的改进将来会有用吧?
3)当第一个参数 PatternType 是 AcPatternType 枚举类型且其值为 acHatchPatternTypeCustomDefined = 2(自定义)时,本参数应使用图形界面“填充图案选项板”上的“自定义”选项卡上的图案名称。我没自定义过填充图案,我的这个选项卡上也是一片空白,所以这个枚举值对我也是没有用的。
4)当第一个参数PatternType AcGradientPatternType 枚举类型且其值为acPreDefinedGradient = 0(预定义)时,本参数为下列9个名称之一:
  K; h% U1 q; G5 ~9 `3 o8 B
     1"Linear"2"Cylinder"3"InvCylinder"4"Spherical"5"HemiSpherical"6"Curved"7"InvSpherical"8"InvHemiSpherical"9"InvCurved"    ,对应图案如下:
004.jpg     005.jpg

2 B7 T# v: y$ c& i. p  D
5、第三参数: Associativity(是否关联)   参考如上右图
Boolean[布尔值]; 仅用于输入,TRUE: 图案填充为关联的。
FALSE: 图案填充为不关联的。
作用:当填充图案的边界发生变化时,填充的图案是否自动适应边界的变化。
省略时默认是FALSE(不关联,即不勾选)。但是第三参数仍然要定义变量,可以不赋值。

* F4 e( D* y4 z" c* m  z- p4 u0 N& |2 f

  k; Y7 A) J( [+ \: t1 i. W0 T综上,第一个参数就取 0,第二个参数根据第四个参数的值取现有的图案填充名称或渐变名称,第四个参数决定第二参数的选择是图案填充还是渐变填充,图案名称必须是符合第四参数指定的类型中的图案名称。/ u  W! c* ?* @* U
0 x: b- Z! I7 j9 D1 r5 F
二、创建填充的步骤和要求
首先用 AddHatch 方法创建填充对象;紧接着用Hatch 对象的 AppendOuterLoop 方法明确外边界;如果填充内部有空白,还要用 AppendInnerLoop 方法添加内边界,有几个内边界就用几次。边界必须是封闭的。组成边界的多个图元之间必须是首尾相连的,换句话说,组成边界的多个图元之间不允许交叉,只允许且必须端点重合。
在实际测试中发现使用图案填充时,添加完外边界后刷新界面,然后添加内边界无效!但是渐变填充却没事!
内边界与外边界不许交叉,各个内边界之间也不许交叉。
内边界可以内部还有内边界,就是两个内边界“嵌套”组成环形。
内边界内部是否填充、嵌套的内边界怎样填充,可以用 Hatch 对象的 HatchStyle 属性(孤岛检测样式)来决定。可以在图形界面打开“特性”管理器,再选择一个有内边界的填充对象,在“特性”管理器中修改“孤岛检测样式”属性查看效果。
  1. Sub AddHatch方法()
    - B, h# P, ?6 k' g4 N, b; e5 i9 C
  2.     Rem 语法:RetVal = Object.AddHatch(PatternType, PatternName, Associativity [, HatchObjectType])8 T' s8 W" Q2 l+ R9 J
  3.     Dim HatchObject As AcadHatch            '定义填充图案对象
    / J! P/ t' V8 `
  4.     Rem 定义填充类型为长整型,取值为图案填充的0,1,2;渐变填充的0,1,一般就取0(CAD预定义)5 R! a- S: U/ ~# G" H& Z
  5.     Dim hatchtype As AcPatternType       '参数4设置为图案填充的类型,参数4若是渐变填充,则定义为AcGradientPatternType类型& m+ X4 }4 j! a5 @# ]2 w
  6.     '    Dim hatchtype As AcGradientPatternType
    , k7 _' T2 a7 |4 M+ |. U# b; w$ G, U
  7.     Dim HatchName As String                   '定义图案名称为字符串类型
    ' s9 V' X! t2 u
  8.     Dim HatchAssociativity As Boolean       '定义关联类型为布尔值,取值为True表示关联,False表示非关联。
    ( W/ Z0 C, ~' a' e
  9.     Dim HObjectType As AcHatchObjectType    '定义图案对象类型,取值为“图案填充-0”、“渐变填充-1”。省略默认为0.
    % |3 j% i- @3 s' [7 _
  10. 9 `3 D3 e$ B* D9 D; M0 R
  11.     Rem 首先添加几个边界以备填充使用5 R( l# a" ~) |. ?; k3 E- u# j
  12.     Dim L As AcadLWPolyline, cir1 As AcadCircle, cir2 As AcadCircle, CIR3 As AcadCircle   '定义一个多段线和三个圆
    4 f7 y" F$ _; R8 X7 }
  13.     Dim pts(11) As Double, P0(2) As Double, R As Double   '定义多段线端点变量,圆心变量,半径变量( G  G$ k6 L% R' c  p, f; k2 ]
  14.     pts(0) = 0: pts(1) = 0: pts(2) = 20: pts(3) = 15: pts(4) = 10: pts(5) = 30
    - E( k; S* y2 Q& t/ P- @% r! [0 Z
  15.     pts(6) = 50: pts(7) = 50: pts(8) = 0: pts(9) = -70: pts(10) = -70: pts(11) = 32
      y, w/ }+ A+ d7 ?% Z
  16.     Set L = ThisDrawing.ModelSpace.AddLightWeightPolyline(pts)
    * Y; S& Y6 d) F# }* D
  17.     Update
    8 T5 f, J4 d& U& v% E+ b) m; i& t
  18.     L.Closed = True   '将多段线闭合
    " l" e- B3 |& M) O
  19.     Update! l# G  l1 e# I5 i$ {
  20.     P0(0) = 0: P0(1) = 0: P0(2) = 0
    . m7 g1 d/ {5 ^& s4 m5 G
  21.     R = 253 _% j+ m5 x7 Q) h8 M( Z$ M4 D
  22.     Set cir1 = ThisDrawing.ModelSpace.AddCircle(P0, R)0 H8 `5 C& ]9 p' [4 O& z
  23.     Update
    6 |4 o' g7 d: R+ t5 ^
  24.     R = 50
    / M. W0 i& q% h5 u0 H, n- f! u
  25.     Set cir2 = ThisDrawing.ModelSpace.AddCircle(P0, R)
    7 P, ~! P2 o6 A$ e' c
  26.     Update
    4 F" q. O- X( z- `6 h
  27.     R = 702 d4 O: `3 L6 J/ K" c  j, I
  28.     Set CIR3 = ThisDrawing.ModelSpace.AddCircle(P0, R)1 s5 u4 G2 f  H5 Z
  29.     Update5 ^& S0 g3 [+ T0 d1 G! z) F
  30.    
    8 N7 ^# a. l$ U
  31.     Rem 接下来赋值图案填充变量,先复制第四参数,再赋值第一参数、第二参数、第三参数
    2 \' k7 j0 ]7 P0 m2 p: b, Z
  32.     HObjectType = 1   '写0也可以直接写acHatchObject,表示图案填充类型,都省略默认为0;写1也可以写成acGradientObject,表示渐变填充8 r8 D7 B( q' p0 Q
  33.     '    HObjectType = acGradientObject '也可以直接写1,表示渐变填充类型
    * W. Y( ^6 j+ u' B) y4 q
  34.     Rem 第一参数值英文名称太长,还是直接记住数字好了!
    , U0 A1 k7 Q% F
  35.     hatchtype = 0       'acHatchPatternTypePreDefined,参数太长,直接记住数字吧!
    + M! T0 v0 c% l8 Y6 t. y. n7 V- g' `, ~
  36.     '    HatchType = 1      'acHatchPatternTypeUserDefined
    % @2 q3 n5 D! s' V  E6 S
  37.     '    HatchType = 2      'acHatchPatternTypeCustomDefined,第四参数为1时此参数无效!
    , n+ Q  z" e% Z
  38.     Rem 以下四类图案名称仅在第四参数=0时有效!每一类里有数个名称可用!
    ( L9 d4 R5 ]) i# J
  39.     '    HatchName = "ANSI32"
    ! j$ t2 j( p  Q$ i/ H* i. v1 _
  40.     '    HatchName = "ISO02W100"    '此处的名字到底是什么?
    ) v6 v3 b* z, U2 B# d( l
  41.     '    HatchName = "AR-HBONE"7 G8 W$ |- T8 y2 I9 G3 x
  42.     '    HatchName = "STARS"
    , L+ @. H' X' s1 s9 C: ^: w& c5 U
  43.     Rem  以下9种图案名称仅在第四参数=1时有效!表示渐变填充名称,只有这9个名称。
    6 s8 G: U! G8 I6 r
  44.     '    HatchName = "Linear"               '对应第1行第1列图案
    % z9 m3 S: ?- @/ Z
  45.     '    HatchName = "Cylinder"             '对应第1行第2列图案: J) k; Z* F% n
  46.     '    HatchName = "InvCylinder"          '对应第1行第3列图案
    , u2 ]3 `) P$ e/ E, u
  47.     HatchName = "Spherical"            '对应第2行第1列图案
    ) m3 F0 o% H% |: {3 @+ [
  48.     '    HatchName = "HemiSpherical"        '对应第2行第2列图案% ]3 i/ {/ p' Z! z8 b9 y7 H
  49.     '    HatchName = "Curved"               '对应第2行第3列图案6 H) W: V; y, f( q( P
  50.     '    HatchName = "InvSpherical"         '对应第3行第1列图案
    ' ?$ Q. X# b5 q7 Z2 P, f% Z+ x$ o
  51.     '    HatchName = "InvHemiSpherical"     '对应第3行第2列图案# z" i2 v/ x& @1 b8 X0 Z
  52.     '    HatchName = "InvCurved"            '对应第3行第3列图案
    * C' o- z7 }1 R
  53.     Rem 第三参数一般设置为true(关联)
    2 \- ?) t% c/ o+ o
  54. '    HatchAssociativity = True        '省略赋值时默认为False
    * G( x% C' C  _1 f- M& O  ^
  55.     '    HatchAssociativity = False
    3 U% J0 Z  f# i0 c6 j
  56.    
    1 s4 u( l6 @/ d9 f( S9 K" z/ B
  57.     Rem 首先创建图案填充,然后创建图案外边界和内边界4 F9 Q  ?9 `6 Q4 @- T& c+ V
  58.     Set HatchObject = ThisDrawing.ModelSpace.AddHatch(hatchtype, HatchName, HatchAssociativity, HObjectType)
      @, z/ @$ l6 R) k+ Y1 S0 P
  59.     '    Set HatchObject = ThisDrawing.ModelSpace.AddHatch(0, "ANSI32", True, 0)   '也可以直接写参数值
    + r. Q# F" q; o8 K( O
  60.     Dim OUTLOOP(0) As AcadEntity    '定义外边界为CAD实体类型
    2 `  r5 M# L+ Q; S0 A3 h- W* c5 k
  61.     Set OUTLOOP(0) = CIR3      '将cir1圆赋给外边界( k& F5 y. L7 h" D4 E
  62.     HatchObject.AppendOuterLoop (OUTLOOP)    '设置图案填充的外边界# W. W' c6 P2 }2 T2 Y0 S
  63.     Update   '添加内边界之前刷新界面,后续图案填充内边界添加无效!但是渐变填充可以!
    4 p0 |) k) z3 i
  64.     Dim INTLOOP(0) As AcadEntity    '定义内边界为CAD实体类型
    2 E/ a/ G/ B0 s. M  ~! D6 x) o
  65.     Set INTLOOP(0) = cir2           '将cir2圆赋给第一个内边界,如果内边界比外边界大,则出错!
    6 u1 r& I& x: \7 J# m8 Q( U
  66.     HatchObject.AppendInnerLoop (INTLOOP)    '设置图案填充的内边界, r6 P% `4 `% i. y
  67.     Update& c* S: v/ G' A3 ^* ~
  68.     Set INTLOOP(0) = L           '将cir3圆赋给第二个内边界,同时设置两个内边界不好使!要一个一个设置' r0 Q5 `$ F5 o4 a5 U+ E3 r
  69.     HatchObject.AppendInnerLoop (INTLOOP)    '设置图案填充的内边界1 T5 r8 v% P  O+ Z& j" k4 |
  70.     Update
    : g9 r9 q' P4 M
  71. End Sub
复制代码

: K, I2 n% c+ f; } 2.11.02、创建图案填充的补充.zip (11.2 KB, 下载次数: 1)
发表于 2019-5-30 21:26:40 | 显示全部楼层
很好很强大

点评

这么久了终于打破了0回复!  发表于 2019-5-31 20:38
发表于 2019-6-2 13:30:00 | 显示全部楼层
楼主很用心啊,顶一下!

点评

谢谢!  发表于 2019-6-2 13:46
发表回复
您需要登录后才可以回帖 登录 | 注册

本版积分规则



Licensed Copyright © 2016-2020 http://www.3dportal.cn/ All Rights Reserved 京 ICP备13008828号

小黑屋|手机版|Archiver|三维网 ( 京ICP备13008828号 )

快速回复 返回顶部 返回列表